import javax.microedition.lcdui.Graphics;
public class Triangle extends Face{
public Vertex v1,v2,v3;
float nx,ny,nz,rnx,rny,rnz,k;
public Triangle(Vertex a,Vertex b,Vertex c,int col){
v1=a;
v2=b;
v3=c;
color=col;
nx = ((v1.y-v2.y)*(v1.z-v3.z))-((v1.z-v2.z)*(v1.y-v3.y));
ny = ((v1.z-v2.z)*(v1.x-v3.x))-((v1.x-v2.x)*(v1.z-v3.z));
nz = ((v1.x-v2.x)*(v1.y-v3.y))-((v1.y-v2.y)*(v1.x-v3.x));
float length=(float)(Math.sqrt(nx*nx+ny*ny+nz*nz));
nx/=length;
ny/=length;
nz/=length;
rnx=nx;
rny=ny;
rnz=nz;
}
public int getS(){
return (v1.zc+v2.zc+v3.zc)/3;
}
public void paint(Graphics g,boolean l){
if(l){
k=rnz;
if(k>0)
k=-k;
if(k<-1)
k=-1;
int rc=color>>16&0xff,gc=color>>8&0xff,bc=color&0xff;
rc=(int)(rc*-k);
gc=(int)(gc*-k);
bc=(int)(bc*-k);
paint(g,rc<<16|gc<<8|bc);
}
else
paint(g,color);
}
public void paint(Graphics g,int col){
if(v1.zc<Camera.z||v2.zc<Camera.z||v3.zc<Camera.z)
return;
if(v1.zc>Camera.limit&&v2.zc>Camera.limit&&v3.zc>Camera.limit)
return;
if(v1.sx<0&&v2.sx<0&&v3.sx<0)
return;
if(v1.sx>Camera.w&&v2.sx>Camera.w&&v3.sx>Camera.w)
return;
if(v1.sy<0&&v2.sy<0&&v3.sy<0)
return;
if(v1.sy>Camera.h&&v2.sy>Camera.h&&v3.sy>Camera.h)
return;
g.setColor(col);
g.fillTriangle(v1.sx,v1.sy,v2.sx,v2.sy,v3.sx,v3.sy);
}
public void move(int x,int y,int z){
v1.move(x,y,z);
v2.move(x,y,z);
v3.move(x,y,z);
}
public void setMatrix(Matrix3D m){
v1.setMatrix(m);
v2.setMatrix(m);
v3.setMatrix(m);
rnx=(nx*m.xx+ny*m.xy+nz*m.xz);
rny=(nx*m.yx+ny*m.yy+nz*m.yz);
rnz=(nx*m.zx+ny*m.zy+nz*m.zz);
}
}