//      -  ,   

import java.util.*;
import javax.microedition.lcdui.Graphics;
public class Group
{
    public int ax,ay,az,maxx,maxy,maxz,minx,miny,minz;
    public Vector f,v;
    public String name="";
    public boolean visible=true;
    public Group(){
        f=new Vector();
        v=new Vector();
        int id=0;
        if(Main.main.e.m!=null)id=Main.main.e.m.g.size();
        name="Group_"+id;
    }
    public Group(Face[] t,String n,int in){
        f=new Vector();
        v=new Vector();
        if(t==null)return;
        for(int i=0;i<t.length;i++){
            Face fc=t[i];
            f.addElement(fc);
            if(fc instanceof Triangle){
                Triangle tr=(Triangle)fc;
                if(!v.contains(tr.a))v.addElement(tr.a);
                if(!v.contains(tr.b))v.addElement(tr.b);
                if(!v.contains(tr.c))v.addElement(tr.c);
            }
            else{
                Line l=(Line)fc;
                if(!v.contains(l.a))v.addElement(l.a);
                if(!v.contains(l.b))v.addElement(l.b);
            }
        }
        if(in>=0){verNorm();}
        name=n+"_"+in;
    }
    
    public void triNorm(){ //   
        for (int i=0;i<f.size();i++){
            if(f.elementAt(i) instanceof Triangle)
                ((Triangle)f.elementAt(i)).norm();}
    }
    
    public void verNorm(){ //    
        
            int nn;
            for(int i=0;i<v.size();i++){
                Vertex vv=(Vertex)v.elementAt(i);
                nn=0;
                for(int k=0;k<f.size();k++){
                    Triangle tr=(Triangle)f.elementAt(k);
                    if((vv==tr.a||vv==tr.b||vv==tr.c)&&tr.smooth){
                        nn++;
                        vv.nz+=tr.nz;
                        vv.nx+=tr.nx;
                        vv.ny+=tr.ny;
                    }
                }
                    vv.nx/=nn;
                    vv.ny/=nn;
                    vv.nz/=nn;
            }
    }
    
    public void countBoundary(){ //   
        maxx=minx=((Vertex)v.elementAt(0)).x;
        maxy=miny=((Vertex)v.elementAt(0)).y;
        maxz=minz=((Vertex)v.elementAt(0)).z;
        ax=ay=az=0;
        for(int i=0;i<v.size();i++){
            Vertex ve=(Vertex)v.elementAt(i);
            if(ve.x>maxx)maxx=ve.x;
            if(ve.x<minx)minx=ve.x;
            if(ve.y>maxy)maxy=ve.y;
            if(ve.y<miny)miny=ve.y;
            if(ve.z>maxz)maxz=ve.z;
            if(ve.z<minz)minz=ve.z;
            ax+=ve.x;
            ay+=ve.y;
            az+=ve.z;
        }
        ax/=v.size();
        ay/=v.size();
        az/=v.size();
    }
    
       public void draw(Graphics g,Matrix3D n,Vector l) { //  
           if(!visible)return;
              for(int i=0;i<v.size();i++){
                  ((Vertex)v.elementAt(i)).setMatrix(n);
              }
    for (int i = f.size() - 1; i >= 0; --i) {
        if(f.elementAt(i) instanceof Triangle){
      ((Triangle)f.elementAt(i)).setMatrix(n);
      if(((Triangle)f.elementAt(i)).isVisible(0)){
          ((Triangle)f.elementAt(i)).light(l);
          ((Triangle)f.elementAt(i)).paint(g,0);
      }
        }
        else{
            ((Line)f.elementAt(i)).paint(g);
        }
    }
  }
       // shad: 0 - poly, 1 - smooth, 2 - flat, 3 - wire, 4 - bounding box
          public void render(int[] r,int[] z,Matrix3D n,Vector l,int shad, int view) {
              if(!visible)return;
             if(shad!=4){ for(int i=0;i<v.size();i++){
                 Vertex ver=(Vertex)v.elementAt(i);
                  if(view==0)ver.setMatrix(n);
                  if(shad==1)ver.light(l);
                  if(Edit.mo==2){
                      for (int j=ver.sx-4;j<=ver.sx+4;j++){
                          for(int k=ver.sy-4;k<=ver.sy+4;k++){
                              if(j<Statics.w&&j>=0&&k<Statics.h&&k>=0){z[Statics.w*k+j]=(ver.zc-50)<<16;
                              r[Statics.w*k+j]=0x111177;
                              }
                          }
                      }
                  }
              }
    for (int i = f.size() - 1; i >= 0; --i) {
        if(Editor.sel2!=null&&Editor.sel2.contains(f.elementAt(i))&&Edit.mo==1) continue;
        if(f.elementAt(i) instanceof Triangle){
          Triangle t=((Triangle)f.elementAt(i));  
      t.setMatrix(n);
      if(t.isVisible(view)){
          if((shad==1&&!t.smooth)||shad==0)t.light(l);
          t.render(r,z,shad,view);}
        }
      else{
      Line line=(Line)f.elementAt(i);
      line.render(r, z,view);
      }
    }}
             else{
                 Group gr=new Group(Create.wireBox(new Vertex(minx,miny,minz), new Vertex(maxx,maxy,maxz), 0xffffff),null,-1);
                 gr.render(r, z, n, null, 3,view);
             }
  } 
          
          public int[] getBounce(Matrix3D m){ //   (2D)
              int[] b=new int[5];
              Vertex ve=(Vertex)v.firstElement();
              ve.setMatrix(m);
              b[0]=b[2]=ve.sx;
              b[1]=b[3]=ve.sy;
              b[4]=ve.zc;
              for (int i=0;i<v.size();i++){
                  ve=(Vertex)v.elementAt(i);
                  ve.setMatrix(m);
              if(ve.sx<b[0])b[0]=ve.sx;
              if(ve.sy<b[1])b[1]=ve.sy;
              if(ve.sx>b[2])b[2]=ve.sx;
              if(ve.sy>b[3])b[3]=ve.sy;
              if(ve.zc<b[4])b[4]=ve.zc;
              }
              return b;
          }
          
                    public int[] getVolumeBounce(Matrix3D m){ //   (3D)
              int[] b=new int[6];
              Vertex ve=(Vertex)v.firstElement();
              ve.setMatrix(m);
              b[0]=b[3]=ve.x;
              b[1]=b[4]=ve.y;
              b[2]=b[5]=ve.z;
              for (int i=0;i<v.size();i++){
                  ve=(Vertex)v.elementAt(i);
                  ve.setMatrix(m);
              if(ve.x<b[0])b[0]=ve.x;
              if(ve.y<b[1])b[1]=ve.y;
              if(ve.z<b[2])b[2]=ve.z;
              if(ve.x>b[3])b[3]=ve.x;
              if(ve.y>b[4])b[4]=ve.y;
              if(ve.z>b[5])b[5]=ve.z;
              }
              return b;
          }
          
          public boolean picking(int x,int y){ //      
              boolean b=false;
              for (int i=0;i<f.size();i++){
              Face face=(Face)f.elementAt(i);
              if(!b) b=face.picking(x, y);
          }
              return b;
          }
          
          public void soequal(Matrix3D m,int type){ //   
              for(int i=0;i<v.size();i++){
                  ((Vertex)v.elementAt(i)).setMatrix(m);
                  ((Vertex)v.elementAt(i)).soequal();
                  if(type==1){((Vertex)v.elementAt(i)).soeqNorm(); ((Vertex)v.elementAt(i)).normalize();}
              }
              if(type==1)for(int i=0;i<f.size();i++){
                  ((Face)f.elementAt(i)).setMatrix(m);
                  ((Face)f.elementAt(i)).soequal();
              }
          }
          
          
          public void add(Face fc){ //    
            f.addElement(fc);
            if(fc instanceof Triangle){
                Triangle tr=(Triangle)fc;
                int in=findVertex(tr.a.x,tr.a.y,tr.a.z);
                if(in==-1)v.addElement(tr.a); else tr.a=(Vertex)v.elementAt(in);
                in=findVertex(tr.b.x,tr.b.y,tr.b.z);
                if(in==-1)v.addElement(tr.b); else tr.b=(Vertex)v.elementAt(in);
                in=findVertex(tr.c.x,tr.c.y,tr.c.z);
                if(in==-1)v.addElement(tr.c); else tr.c=(Vertex)v.elementAt(in);
          }
          }
          
          private int findVertex(int x,int y,int z){ //    
              for(int i=0;i<v.size();i++){
                  Vertex ver=(Vertex)v.elementAt(i);
                  if(ver.x==x&&ver.y==y&&ver.z==z)return i;
                      }
              return -1;
          }
          
          public void setMaterial(Material m){ //  
              for(int i=0;i<f.size();i++){
                  if(f.elementAt(i) instanceof Triangle)
                  ((Triangle)f.elementAt(i)).material=m;
              }
          }
          
          public void deleteVertexSafety(Vertex v){
              
          }
}