// загрузчик моделей s3d, obj и wax из файлов. Wax бывает не корректен из-за группированных объектов, которые здесь не поддерживаются

/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
import java.io.*;
import java.util.Vector;
import javax.microedition.io.*;
import javax.microedition.io.file.*;
import javax.microedition.lcdui.Image;
/**
 *
 * @author Shaman
 */
public class Loader {
    int p;
    public Loader(){
    }
    public Model openWax(InputStream ist){
        Model m=new Model();
        Matrix3D n=Main.main.e.n;
        String s=" ";
        try{
            DataInputStream is=new DataInputStream(ist);
            byte[] b=new byte[is.available()];
            is.read(b);
            s=new String(b);
            is.close();
            double[] in;
            while(p>=0){
            p=s.indexOf("<object",p);
            if(p<0)break;
            int k=s.indexOf('"',p);
            int k1=s.indexOf('"', k+1);
            String obj=s.substring(k+1, k1);
            if(!obj.equals("sphere")&&!obj.equals("cylinder")&&!obj.equals("box")){p++; continue;}
            k=s.indexOf('"',k1+1);
            k1=s.indexOf('"', k+1);
            in=getNums(s.substring(k+1, k1)); //location
            float xo=(float)(in[0]*200),yo=(float)(in[1]*200),zo=(float)(in[2]*200);
            k=s.indexOf('"',k1+1);
            k1=s.indexOf('"', k+1);
            in=getNums(s.substring(k+1, k1)); // rotation
            double x=in[0],y=in[1],z=in[2];
            k=s.indexOf('"',k1+1);
            k1=s.indexOf('"', k+1);
            in=getNums(s.substring(k+1, k1)); // scale
            double xs=in[0],ys=in[1],zs=in[2];
            k=s.indexOf('"',k1+1);
            k1=s.indexOf('"', k+1);
            int[] inn=getNumms(s.substring(k+1, k1)); // color
            if(obj.equals("sphere")){
            m.add(Create.sphere(new Vertex(0,0,0), 500, 7, 7, (inn[0]<<16)|(inn[1]<<8)|(inn[2])), obj);
            }
            else if(obj.equals("cylinder")){
                m.add(Create.cylinder(new Vertex(0,-500,0), 500, 1000, 10, (inn[0]<<16)|(inn[1]<<8)|(inn[2])), obj);
            }
            else if(obj.equals("box")){
                m.add(Create.box(new Vertex(-500,-500,500), new Vertex(500,500,-500), ((inn[0]<<16)|(inn[1]<<8)|(inn[2]))), obj);
            }
            else{p++; continue;
            }
            if(!m.g.isEmpty()){
                Group gr=m.getLast();
            n.unit();
            n.scale((float)xs,(float)ys, (float)zs);
            n.yrot(y);
            n.xrot(x);
            n.zrot(z);
            n.translate(-xo, yo, zo);
            gr.soequal(n,1);
            gr.countBoundary();
            }
            p++;
            }
        }catch(Exception e){return m;
        }
        return m;
        
    }
    private double[] getNums(String s){
        try{
            double[] ret=new double[3];
        int pos1=0,pos=s.indexOf(',');
        ret[0]=Double.parseDouble(s.substring(pos1, pos-1));
        pos1=s.indexOf(',',pos+1);
        ret[1]=Double.parseDouble(s.substring(pos+1, pos1-1));
        ret[2]=Double.parseDouble(s.substring(pos1+1));
        //f.append(""+ret[0]+","+ret[1]+","+ret[2]+"; ");
        return ret;
        }catch(Exception e){
        }
        //f.append("ошибка; ");
        return new double[]{0,0,0};
    }
    private int[] getNumms(String s){
        int[] ret=new int[3];
        int pos1=0,pos=s.indexOf(',');
        ret[0]=Integer.parseInt(s.substring(pos1, pos));
        pos1=s.indexOf(',',pos+1);
        ret[1]=Integer.parseInt(s.substring(pos+1, pos1));
        ret[2]=Integer.parseInt(s.substring(pos1+1));
        return ret;
    }
    
    public Model loadObj(InputStream is){
        Model m=new Model();
        boolean vt=false,vn=false,readFace=false;
        int vert=0;
            Vector uv=new Vector();
            Vector vno=new Vector();
            Group gr=new Group();
            
        try{
            //InputStream is=getClass().getResourceAsStream("/file.txt");
            DataInputStream dis=new DataInputStream(is);
            byte by;
            while(dis.available()>0){
            by=dis.readByte();
            if(by=='v'){
                byte b=dis.readByte();
            if(b==' '){
                if(readFace){m.add(gr); gr.countBoundary();gr.triNorm(); if(!vn){gr.verNorm(); } vert+=gr.v.size(); gr=new Group(); readFace=false;vt=false;vn=false; }
            readVertexInfo(dis,gr); }
            else{
            byte b1=dis.readByte();
            if(b1==' '){
            if(b=='t'){if(!vt)vt=true; readUVInfo(dis,uv);}
            else if(b=='n'){if(!vn)vn=true;readNormInfo(dis,vno); }
            }
            }
            }
            else if(by=='f'){if(dis.readByte()==' '){if(!readFace)readFace=true; readFaceInfo(dis,gr,uv,vno,vn,vt,vert); }}
            else if(by=='g'){if(dis.readByte()==' '){String st=new String(); while(by!=10&&by!=13){by=dis.readByte();st=st+(char)by;} gr.name=st; } }
            else{ while(by!=10&&by!=13&&dis.available()>0) by=dis.readByte(); }
            }
            if(gr.v.size()>0&&gr.f.size()>0){m.add(gr); gr.triNorm(); if(!vn)gr.verNorm(); gr.countBoundary(); }
            dis.close();
        }catch(Exception e){return m;
        }
        return m;
    }
    
    public void readVertexInfo(DataInputStream dis,Group gr) throws IOException{
    byte b=dis.readByte();
    String s=new String(); 
        while(b==' ')
        b=dis.readByte();
    while(b!=' '){
        if((char)b>='0'&&(char)b<='9'||b=='-'||b=='.')s=s+(char)b;
        b=dis.readByte();
    }
    float xx;
    if(s.length()>0) xx=Float.parseFloat(s); else xx=0f;
    while(b==' ')
        b=dis.readByte();
    s=new String();
    while(b!=' '){
        if((char)b>='0'&&(char)b<='9'||b=='-'||b=='.')s=s+(char)b;
        b=dis.readByte();
    }
    float yy;
    if(s.length()>0) yy=Float.parseFloat(s); else yy=0f;
    while(b==' ')
        b=dis.readByte();
    s=new String();
    while(b!='\n'){
        if((char)b>='0'&&(char)b<='9'||b=='-'||b=='.')s=s+(char)b;
        b=dis.readByte();
    }
    float zz;
    if(s.length()>0)zz=Float.parseFloat(s); else zz=0f;
    Vertex v3f=new Vertex((int)(xx*10),(int)(yy*10),(int)(zz*10));
    gr.v.addElement(v3f);
    }
    
    //texture coordinates
    public void readUVInfo(DataInputStream dis,Vector uv) throws IOException{
        String s=new String();
        byte b=dis.readByte();
        while(b==' ')
            b=dis.readByte();
        while(b!=' '){
            if((char)b>='0'&&(char)b<='9'||b=='-'||b=='.')s=s+(char)b;
            b=dis.readByte();
        }
        Float uu;
        if(s.length()>0) uu=new Float(Float.parseFloat(s)); else uu=new Float(0f);
        while(b==' ')
            b=dis.readByte();
        s=new String();
        while(b!=' '&&b!='\n'&&b!='\r'){
            if((char)b>='0'&&(char)b<='9'||b=='-'||b=='.')s=s+(char)b;
            b=dis.readByte();
        }
        Float vv;
        if(s.length()>0) vv=new Float(Float.parseFloat(s)); else vv=new Float(0f);
        uv.addElement(uu);
        uv.addElement(vv);
    }
    
    public void readNormInfo(DataInputStream dis,Vector v) throws IOException{
    byte b=dis.readByte();
    String s=new String(); 
        while(b==' ')
        b=dis.readByte();
    while(b!=' '){
        if((char)b>='0'&&(char)b<='9'||b=='-'||b=='.')s=s+(char)b;
        b=dis.readByte();
    }
    Float xx;
    if(s.length()>0) xx=new Float(Float.parseFloat(s)); else xx=new Float(0f);
    v.addElement(xx);
    while(b==' ')
        b=dis.readByte();
    s=new String();
    while(b!=' '){
        if((char)b>='0'&&(char)b<='9'||b=='-'||b=='.')s=s+(char)b;
        b=dis.readByte();
    }
    Float yy;
    if(s.length()>0) yy=new Float(Float.parseFloat(s)); else yy=new Float(0f);
    v.addElement(yy);
    while(b==' ')
        b=dis.readByte();
    s=new String();
    while(b!='\n'){
        if((char)b>='0'&&(char)b<='9'||b=='-'||b=='.')s=s+(char)b;
        b=dis.readByte();
    }
    Float zz;
    if(s.length()>00) zz=new Float(Float.parseFloat(s)); else zz=new Float(0f);
    v.addElement(zz);
    }
    
    //polygons
    public void readFaceInfo(DataInputStream dis,Group gr,Vector uv,Vector vno,boolean vn,boolean vt,int vert) throws IOException{
        Vector f=new Vector();
        byte b=dis.readByte();
        while(b!='\n'&&b!='\r'&&dis.available()>0){
        String s=new String();
            if(b==' '){
    while(b==' '){
        //if(dis.available()<=0)break;
        b=dis.readByte();}}
            else if(b=='/'){while(b=='/')b=dis.readByte();}
    while(b!=' '&&b!='/'&&b!='\n'&&b!='\r'){
        if((char)b>='0'&&(char)b<='9')s=s+(char)b;
        //if(dis.available()<=0)break;
        if(dis.available()>0)b=dis.readByte();
    }
    if(s.length()>0){Integer ind=new Integer(Integer.parseInt(s));
            f.addElement(ind);}
            //if(b=='\n'||b=='\r'||dis.available()<=0)break;
        }
        
        if(!vn&&!vt){
        for(int i=1;i<=f.size()-2;i++)
            gr.add(new Triangle((Vertex)gr.v.elementAt(((Integer)f.elementAt(0)).intValue()-vert-1),(Vertex)gr.v.elementAt(((Integer)f.elementAt(i)).intValue()-vert-1),(Vertex)gr.v.elementAt(((Integer)f.elementAt(i+1)).intValue()-vert-1),0xffffff));
        }
        else if(vn^vt){
        for(int i=0; i<f.size()-4;i+=2){
            Triangle t=new Triangle((Vertex)gr.v.elementAt(((Integer)f.elementAt(0)).intValue()-vert-1),(Vertex)gr.v.elementAt(((Integer)f.elementAt(i+2)).intValue()-vert-1),(Vertex)gr.v.elementAt(((Integer)f.elementAt(i+4)).intValue()-vert-1),0xffffff);
            gr.add(t);
            //f.addElement(new Integer(100500));
            if(vn){
                t.a.nx=((Float)vno.elementAt((((Integer)f.elementAt(1)).intValue()-1)*3)).floatValue();
                t.a.ny=((Float)vno.elementAt((((Integer)f.elementAt(1)).intValue()-1)*3+1)).floatValue();
                t.a.nz=((Float)vno.elementAt((((Integer)f.elementAt(1)).intValue()-1)*3+2)).floatValue();
                t.b.nx=((Float)vno.elementAt((((Integer)f.elementAt(i+3)).intValue()-1)*3)).floatValue();
                t.b.ny=((Float)vno.elementAt((((Integer)f.elementAt(i+3)).intValue()-1)*3+1)).floatValue();
                t.b.nz=((Float)vno.elementAt((((Integer)f.elementAt(i+3)).intValue()-1)*3+2)).floatValue();
                t.c.nx=((Float)vno.elementAt((((Integer)f.elementAt(i+5)).intValue()-1)*3)).floatValue();
                t.c.ny=((Float)vno.elementAt((((Integer)f.elementAt(i+5)).intValue()-1)*3+1)).floatValue();
                t.c.nz=((Float)vno.elementAt((((Integer)f.elementAt(i+5)).intValue()-1)*3+2)).floatValue();
                t.norm((t.a.nx+t.b.nx+t.c.nx)/3,(t.a.ny+t.b.ny+t.c.ny)/3,(t.a.ny+t.b.ny+t.c.ny)/3);
                t.setUV();
            }
            else{
            t.uv=new float[]{((Float)uv.elementAt((((Integer)f.elementAt(1)).intValue()-1)*2)).floatValue(),((Float)uv.elementAt((((Integer)f.elementAt(1)).intValue()-1)*2+1)).floatValue(),((Float)uv.elementAt((((Integer)f.elementAt(i+3)).intValue()-1)*2)).floatValue(),((Float)uv.elementAt((((Integer)f.elementAt(i+3)).intValue()-1)*2+1)).floatValue(),((Float)uv.elementAt((((Integer)f.elementAt(i+5)).intValue()-1)*2)).floatValue(),((Float)uv.elementAt((((Integer)f.elementAt(i+5)).intValue()-1)*2+1)).floatValue()};
            }
        }
        }
        else if(vn&&vt){
        for(int i=1;i<=f.size()/3-2;i+=3){
        Triangle t=new Triangle((Vertex)gr.v.elementAt(((Integer)f.elementAt(0)).intValue()-vert-1),(Vertex)gr.v.elementAt(((Integer)f.elementAt(i+2)).intValue()-vert-1),(Vertex)gr.v.elementAt(((Integer)f.elementAt(i+5)).intValue()-vert-1),0xffffff);
            gr.add(t);
        //t.a.nx=()
        }
        }
    }
    
    public Model loadResourceAsS3D(String s){
try{
    InputStream is=getClass().getResourceAsStream(s);
Model mod = loadS3D(is);
is.close();
return mod;
}catch(Exception e){ Model mod=new Model(); mod.add(Create.disk(new Vertex(0,0,0), 500, 30, 0x008800), "null"); return mod; }
}
    
    public Model loadS3D(InputStream is){
        try{
            DataInputStream d=new DataInputStream(is);
            int chunk=d.readInt();
            if (chunk==0xffff06)return loadS3D06(d);
            else return loadS3D05(d,chunk);
        }catch(Exception e){return null; }
    }
    
public Model loadS3D05(DataInputStream d,int numFaces){
Model mod=new Model();
Group m=new Group();
try{
int type;
for(int i=0;i<numFaces;i++){
    type=d.readInt();
switch(type){
case 0: readTriangle(d,m);break;
case 1: readSquare(d,m);break;
case 2: readCircle(d,m);break;
case 3: readLine(d,m);break;
}
}
Material mat=new Material();
mat.doubleSided=true;
mat.useFaceColor=true;
m.countBoundary();
m.verNorm();
mod.add(m);
mod.setMaterial(mat);
MaterialEditor.mat.addElement(mat);
d.close();
}catch(Exception e){
mod.add(Create.disk(new Vertex(0,0,0), 500, 30, 0x008800), "null");
}
return mod;
}
public void readTriangle(DataInputStream d,Group m){
try{
Triangle f=new Triangle(nv(d),nv(d),nv(d),d.readInt());
f.smooth=false;
f.norm();
//f.invert();
m.add(f);
//f=null;
}catch(Exception e){}
}
public void readSquare(DataInputStream d,Group m){
try{
    Vertex v1=nv(d);
    Vertex v2=nv(d);
    Vertex v3=nv(d);
    Vertex v4=nv(d);
    int col=d.readInt();
Triangle tr=new Triangle(v4,v2,v1,col);
Triangle tr2=new Triangle(v4,v3,v2,col);
tr.smooth=false;
tr2.smooth=false;
tr.norm();
//tr.invert();
tr2.norm();
//tr2.invert();
m.add(tr);
m.add(tr2);
}catch(Exception e){}
}
public void readCircle(DataInputStream d,Group m){
try{
    Vertex v1=nv(d);
    Vertex v2=nv(d);
    Vertex v=new Vertex((v1.x+v2.x)/2,(v1.y+v2.y)/2,(v1.z+v2.z)/2);
    int col=d.readInt();
    Face[] f=Create.disk(v, Math.sqrt((v.x-v2.x)*(v.x-v2.x)+(v.y-v2.y)*(v.y-v2.y)+(v.z-v2.z)*(v.z-v2.z)), 30, col);
//Circle c=new Circle(nv(d),nv(d),d.readInt());
    for(int i=0;i<f.length;i++)
        m.add(f[i]);
}catch(Exception e){}
}
public void readLine(DataInputStream d,Group m){
try{
    nv(d);
    nv(d);
    d.readInt();
//Line l=new Line(nv(d),nv(d),d.readInt());
//m.add(l);
}catch(Exception e){}
}
public Vertex nv(DataInputStream d){
try{
return new Vertex(d.readInt()*10,d.readInt()*10,d.readInt()*10);
}catch(Exception e){return null;}
}

public Model loadS3D06(DataInputStream d){
   Model m=new Model();
   int i,j;
   try{
       Main.main.e.name=new String();
       j=d.readInt();
       for(i=0;i<j;i++)
           Main.main.e.name=Main.main.e.name+d.readChar();
       Main.main.e.vendor=new String();
       j=d.readInt();
       for(i=0;i<j;i++)
           Main.main.e.vendor=Main.main.e.vendor+d.readChar();
       Main.main.e.description=new String();
       j=d.readInt();
       for(i=0;i<j;i++)
           Main.main.e.description=Main.main.e.description+d.readChar();
       int numMat=d.readInt();
       int numObj=d.readInt();
       int numLights=d.readInt();
       Statics.background=d.readInt();
       Statics.pers=d.readInt();
       Statics.limit=d.readInt();
       for(i=0;i<numMat;i++){
           Material mat=new Material();
           MaterialEditor.mat.addElement(mat);
           int descLength=d.readInt();
           String desc="";
           for(j=0;j<descLength;j++)
               desc=desc+d.readChar();
           mat.desc=desc;
           mat.diffuseColor=d.readInt();
           mat.opacity=d.readInt();
           mat.doubleSided=d.readBoolean();
           mat.useFaceColor=d.readBoolean();
           mat.self=d.readFloat();
           mat.us=d.readFloat();
           mat.vs=d.readFloat();
           mat.uo=d.readFloat();
           mat.vo=d.readFloat();
           if(d.readBoolean()){
               mat.w=d.readInt();
               mat.h=d.readInt();
               mat.texture=new int[mat.w*mat.h];
               int MD=d.readInt();
               int texlength=d.readInt();
               if(MD!=2){
               byte[] b=new byte[texlength];
               d.read(b, 0, texlength);
               Image im=Image.createImage(b, 0, texlength);
               im.getRGB(mat.texture, 0, im.getWidth(), 0, 0, im.getWidth(), im.getHeight());
               }
               else for(j=0;j<texlength;j++){
                   //mat.texture[j]=(d.readByte()<<16)|(d.readByte()<<8)|d.readByte();
                   mat.texture[j]=d.readInt();
               }
           }
       }
       for(i=0;i<numObj;i++){
           Group g=new Group();
           int numchars=d.readInt();
           g.name="";
           for(j=0;j<numchars;j++)
               g.name=g.name+d.readChar();
           g.visible=d.readBoolean();
           int numverts=d.readInt();
           for(j=0;j<numverts;j++){
               Vertex v=new Vertex(d.readInt(),d.readInt(),d.readInt());
               g.v.addElement(v);
               v.nx=d.readFloat();
               v.ny=d.readFloat();
               v.nz=d.readFloat();
           }
           int numfaces=d.readInt();
           for(j=0;j<numfaces;j++){
               Triangle t=new Triangle((Vertex)g.v.elementAt(d.readInt()),(Vertex)g.v.elementAt(d.readInt()),(Vertex)g.v.elementAt(d.readInt()),d.readInt());
               g.f.addElement(t);
               t.nx=d.readFloat();
               t.ny=d.readFloat();
               t.nz=d.readFloat();
               t.smooth=d.readBoolean();
               int mnum=d.readInt();
               if(mnum>=0){
                   t.material=(Material)MaterialEditor.mat.elementAt(mnum);
               }
               if(d.readBoolean()){
                   t.uv=new float[6];
                   t.uv[0]=d.readFloat();
                    t.uv[1]=d.readFloat();
                    t.uv[2]=d.readFloat();
                    t.uv[3]=d.readFloat();
                    t.uv[4]=d.readFloat();
                    t.uv[5]=d.readFloat();
               }
           }
           g.countBoundary();
           m.add(g);
       }
           for(i=0;i<numLights;i++){
               Light l=new Light(d.readInt(),d.readInt(),d.readInt());
               m.l.addElement(l);
           }
           d.close();
   }catch(Exception e){/*m.add(Create.disk(new Vertex(), 500, 30, 0xff00),"");*/
   javax.microedition.lcdui.Form form=new javax.microedition.lcdui.Form("");
   form.append("это капец бля(( "+e.toString());
   Main.main.d.setCurrent(form);
   }
   return m;
}
}
