// сохранятель в s3d

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import java.io.*;
import java.util.Vector;
import javax.microedition.lcdui.Image;
/**
 *
 * @author Александр
 */
public class Saver {
    public static void saveS3D(Model m,Vector mat,OutputStream os){
        int i,j;
        try{
            DataOutputStream dos=new DataOutputStream(os);
            dos.writeInt(0xffff06); //s3d 0.6
            dos.writeInt(Main.main.e.name.length());
            dos.writeChars(Main.main.e.name);
            dos.writeInt(Main.main.e.vendor.length());
            dos.writeChars(Main.main.e.vendor);
            dos.writeInt(Main.main.e.description.length());
            dos.writeChars(Main.main.e.description);
            dos.writeInt(mat.size()); //матерьялы
            dos.writeInt(m.g==null?0:m.g.size()); //объекты
            dos.writeInt(m.l==null?0:m.l.size()); //свет
            dos.writeInt(Statics.background); //фон
            dos.writeInt(Statics.pers); //перспектива
            dos.writeInt(Statics.limit); //предел
            for(i=0;i<mat.size();i++){ //все материалы
                Material ma=(Material)mat.elementAt(i);
                dos.writeInt(ma.desc.length());
                dos.writeChars(ma.desc);
                dos.writeInt(ma.diffuseColor);
                dos.writeInt(ma.opacity);
                dos.writeBoolean(ma.doubleSided);
                dos.writeBoolean(ma.useFaceColor);
                dos.writeFloat(ma.self);
                dos.writeFloat(ma.us);
                dos.writeFloat(ma.vs);
                dos.writeFloat(ma.uo);
                dos.writeFloat(ma.vo);
                if(ma.texture==null)
                    dos.writeBoolean(false);
                else{
                    dos.writeBoolean(true);
                dos.writeInt(ma.w);
                dos.writeInt(ma.h);
                int MD=Statics.textureSaving;
                dos.writeInt(MD);
                if(MD!=2){
                //String str="";
                ByteArrayOutputStream bas=new ByteArrayOutputStream();
                byte[] barray=null;
                if(MD==1){
                //str=Lib_jpeg.saveimagetostring(Image.createRGBImage(ma.texture, ma.w, ma.h, false), 100);
                JpegEncoder je = new JpegEncoder(Image.createRGBImage(ma.texture, ma.w, ma.h, false), 100, bas);
                }
                else if(MD==0){
                    //str=Lib_png3.png_to_string(Image.createRGBImage(ma.texture, ma.w, ma.h, false));
                    barray=Encoder.toPNG(Image.createRGBImage(ma.texture, ma.w, ma.h, false));
                }
                else if(MD==3){
                    Lib_gif.init(100);
                    Lib_gif.add_frame(Image.createRGBImage(ma.texture, ma.w, ma.h, false));
                    Lib_gif.close(bas);
                }
                    if(MD!=0)barray=bas.toByteArray();
                    dos.writeInt(barray.length);
                    dos.write(barray);
                    barray=null;
                //byte[] barray=str.getBytes();
                //dos.writeInt(barray.length);
                //dos.write(barray);
                //barray=null;
                //str=null;
                    bas.flush();
                    bas.close();
                    //bas=null;
                    System.gc();
                }
                else if(MD==2){
                    dos.writeInt(ma.texture.length);
                for(j=0;j<ma.texture.length;j++){
                    /*int r=(ma.texture[j]>>16)&0xff,g=(ma.texture[j]>>8)&0xff,b=ma.texture[j]&0xff;
                    dos.writeInt(r);
                    dos.writeInt(g);
                    dos.writeInt(b);*/
                    dos.writeInt(ma.texture[j]);
                }
                }
                }
            }
            for(i=0;i<m.g.size();i++){
                Group g=(Group)m.g.elementAt(i);
                dos.writeInt(g.name.length());
                dos.writeChars(g.name);
                dos.writeBoolean(g.visible);
                dos.writeInt(g.v.size());
                for(j=0;j<g.v.size();j++){
                    Vertex v=(Vertex)g.v.elementAt(j);
                    dos.writeInt(v.x);
                    dos.writeInt(v.y);
                    dos.writeInt(v.z);
                    dos.writeFloat(v.nx);
                    dos.writeFloat(v.ny);
                    dos.writeFloat(v.nz);
                }
                dos.writeInt(g.f.size());
                for(j=0;j<g.f.size();j++){
                    Triangle t=(Triangle)g.f.elementAt(j);
                    dos.writeInt(g.v.indexOf(t.a));
                    dos.writeInt(g.v.indexOf(t.b));
                    dos.writeInt(g.v.indexOf(t.c));
                    dos.writeInt(t.color);
                    dos.writeFloat(t.nx);
                    dos.writeFloat(t.ny);
                    dos.writeFloat(t.nz);
                    dos.writeBoolean(t.smooth);
                    dos.writeInt(t.material==null?-1:mat.indexOf(t.material));
                    if(t.uv==null)
                        dos.writeBoolean(false);
                    else{
                        dos.writeBoolean(true);
                    dos.writeFloat(t.uv[0]);
                    dos.writeFloat(t.uv[1]);
                    dos.writeFloat(t.uv[2]);
                    dos.writeFloat(t.uv[3]);
                    dos.writeFloat(t.uv[4]);
                    dos.writeFloat(t.uv[5]);
                    }
                }
            }
            if(m.l!=null)for(i=0;i<m.l.size();i++){
                Light l=(Light)m.l.elementAt(i);
                dos.writeInt(l.x);
                dos.writeInt(l.y);
                dos.writeInt(l.z);
            }
            dos.flush();
            dos.close();
        }catch(Exception e){}
    }
}
