/*
 * Экран выбора цвета.
 */
 
/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */

import javax.microedition.lcdui.*;

/**
 * @author Shaman
 */
public class Color extends Canvas{

    int ww,hh,in,k,mode=0,sh; // ширина, высота экрана, текущий редактируемый элемент, клавиатура, текущее окно, и что-то еще
    static int r=0xff,gr=0xff,b=0xff;
    public static int x,y,frame;
    private float h, s, v;
    public static float H = 0;
    private int[] data;
    private int[] colordata;
    private float dh, ds, dv;
    private int offset = 3;
   // private Image buf;
   // private Graphics p;
    /**
     * constructor
     */
    public Color() {
        setFullScreenMode(true);
        ww=getWidth();
        hh=getHeight();
        //buf=Image.createImage(ww, hh);
        //p=buf.getGraphics();
        dh = 360.0f / (float) (ww - 6);
        ds = 255.0f / 128.0f;
        dv = 255.0f / 128.0f;
        colordata = new int[128 * 128];
        sh=Statics.font.getHeight();
    }

    /**
     * paint
     */
    public void paint(Graphics g) {
        g.setFont(Statics.font);
                if(frame==0){
        g.setColor(Statics.menuBack);
        g.fillRect(0, 0, ww,hh);
        g.setColor(0xff0000);
        g.fillRect(5, sh+5, r*(ww/2)/255, 20);
        g.setColor(0x00ff00);
        g.fillRect(15, sh+30, gr*(ww/2)/255, 20);
        g.setColor(0xff);
        g.fillRect(25, sh+55, b*(ww/2)/255, 20);
        g.setColor(r,gr,b);
        g.fillRect(5, sh+90, (ww-10), 25);
         if(in==0)g.setColor(0xffaaaa); else g.setColor(0x677667);
            g.drawRect(5, sh+5, r*(ww/2)/255, 20);
            if(in==1)g.setColor(0xffaaaa); else g.setColor(0x677667);
            g.drawRect(15, sh+30, gr*(ww/2)/255, 20);
            if(in==2)g.setColor(0xffaaaa); else g.setColor(0x677667);
            g.drawRect(25, sh+55, b*(ww/2)/255, 20);
            g.setColor(0x677667);
            g.drawRect(5, sh+90, (ww-10), 25);
            g.setColor(Statics.textColor);
        g.drawString(""+r, ww/2+15, sh+5, 20);
        g.drawString(""+gr, ww/2+25, sh+30, 20);
        g.drawString(""+b, ww/2+35, sh+55, 20);}
                else if(frame==1){
            //g.setColor(0xffff00);
        //g.drawRect(0, 0, ww - 1, hh - 1);
                    if(x>=128)x=127;
                    if(y>=128)y=127;
                    if(x<0)x=0;
                    if(y<0)y=0;
                        g.setColor(Statics.menuBack);
                    g.fillRect(0, 0, ww, hh);
        
        //hsvline
        h = 0;
        for (int i = 0; i < ww - 6; i++) {
            data = HSVtoRGB((int) h, 255, 255);
            h += dh;
            if(Math.abs(Math.floor(H)-Math.floor(h))<=1)
                g.setColor(255-data[0],255-data[1],255-data[2]);
            else
            g.setColor(data[0], data[1], data[2]);
            g.drawLine(offset + i, sh+6, offset + i, sh+24);
        }
                    if(in<1){
                        upData();
                    }
        if(in==0)g.setColor(0xffaaaa); else g.setColor(0x677667);
        g.drawRect(2, sh+5, ww - 5, 20);
        if(in==1)g.setColor(0xffaaaa); else g.setColor(0x677667);
        g.drawRect(15, sh+38, 129, 129);
        g.drawRGB(colordata, 0, 128, 16, sh+39, 128, 128, false);
        g.setColor(colordata[y*128+x]);
        g.fillRect(144, sh+39, 20, 128);
        g.setColor(0x555555);
        g.drawArc(x+9, y+sh+32, 15, 15, 0, 360);
        //g.drawString("" + (int)H, ww/2, sh+39, 20);
        }
            drawLeftSoft(g,frame==0?(Statics.russian?"Палитра":"Palette"):"RGB");
            drawRightSoft(g,"Ok");
        repaint();
        if(k!=0){
        sk();
        }
    }
    
    private void upData(){
                // обновляем HSV-квадрат
        v = 255;
        for (int i = 0; i < 128; i++) {
            s = 255;
            for (int i2 = 0; i2 < 128; i2++) {
                data = HSVtoRGB((int) H, (int) s, (int) v);
                colordata[(i * 128) + i2] = data[0] << 16 | data[1] << 8 | data[2];
                s -= ds;
            }
            v -= dv;
        }
    }
    
    private void drawLeftSoft(Graphics g,String s){
        if(!Statics.touch){
        g.setColor(8947967);
        g.fillRoundRect(0, hh - sh+1, g.getFont().stringWidth(s)+5, sh-1,10,10);
        g.setColor(0);
        g.drawRoundRect(0, hh - sh+1, g.getFont().stringWidth(s)+5, sh-2,10,10);
        g.setColor(0x555555);
        g.drawString(s, 2, hh - 2, 36);
        g.setColor(Statics.textColor);
        g.drawString(s, 3, hh - 1, 36);}
        else{
            g.setColor(8947967);
        g.fillRoundRect(0, hh - 40, g.getFont().stringWidth(s)+5, 39,15,15);
        g.setColor(0);
        g.drawRoundRect(0, hh - 40, g.getFont().stringWidth(s)+5, 38,15,15);
        g.setColor(0x555555);
        g.drawString(s, 2, hh + sh/2 - 20, 36);
        g.setColor(Statics.textColor);
        g.drawString(s, 3, hh +sh/2 - 19, 36);
        }
    }
    
    private void drawRightSoft(Graphics g,String s){
        if(!Statics.touch){
        g.setColor(8947967);
        g.fillRoundRect(ww-g.getFont().stringWidth(s)-5, hh - sh + 1, g.getFont().stringWidth(s)+5, sh-1,10,10);
        g.setColor(0);
        g.drawRoundRect(ww-g.getFont().stringWidth(s)-5, hh - sh + 1, g.getFont().stringWidth(s)+4, sh-2,10,10);
        g.setColor(0x555555);
        g.drawString(s, ww - 4, hh - 2, 40);
        g.setColor(Statics.textColor);
        g.drawString(s, ww - 3, hh - 1, 40);}
        else{
            g.setColor(8947967);
            g.fillRoundRect(ww-g.getFont().stringWidth(s)-5, hh - 40, g.getFont().stringWidth(s)+5, 39,15,15);
            g.setColor(0);
        g.drawRoundRect(ww-g.getFont().stringWidth(s)-5, hh-40, g.getFont().stringWidth(s)+4, 38,15,15);
        g.setColor(0x555555);
        g.drawString(s, ww - 4, hh+sh/2- 20, 40);
        g.setColor(Statics.textColor);
        g.drawString(s, ww - 3, hh+sh/2 - 19, 40);
        }
    }
    
        public static int[] HSVtoRGB(int H, int S, int V) {
        int divisor = 255 * 60;
        int f;
        int hTemp;
        int p, q, t;
        int VS;
        if (S == 0) {
            return new int[]{V, V, V};
        } else {
            if (H == 360) {
                hTemp = 0;
            } else {
                hTemp = H;
            }

            f = hTemp % 60;
            hTemp = hTemp / 60;

            VS = V * S;
            p = V - VS / 255;
            q = V - (VS * f) / divisor;
            t = V - (VS * (60 - f)) / divisor;

            if (hTemp == 0) {
                return new int[]{V, t, p};
            } else if (hTemp == 1) {
                return new int[]{q, V, p};
            } else if (hTemp == 2) {
                return new int[]{p, V, t};
            } else if (hTemp == 3) {
                return new int[]{p, q, V};
            } else if (hTemp == 4) {
                return new int[]{t, p, V};
            } else if (hTemp == 5) {
                return new int[]{V, p, q};
            } else {
                return new int[]{0, 0, 0};
            }
        }
    }
        
        public static float[] RGBtoHSV(float rr,float gg,float bb){
            float computedH,computedS,computedV;
 
  rr=rr/255; gg=gg/255; bb=bb/255;
 float minRGB = Math.min(rr,Math.min(gg,bb));
 float maxRGB = Math.max(rr,Math.max(gg,bb));

 // Black-gray-white
 if (minRGB==maxRGB) {
  computedV = minRGB*255;
  return new float[]{0,255,255-computedV};
 }

 // Colors other than black-gray-white:
 float dd = (rr==minRGB) ? gg-bb : ((bb==minRGB) ? rr-gg : bb-rr);
 float hh = (rr==minRGB) ? 3 : ((bb==minRGB) ? 1 : 5);
 computedH = 60*(hh - dd/(maxRGB - minRGB));
 computedS = 255*(maxRGB - minRGB)/maxRGB;
 computedV = maxRGB*255;
 return new float[]{computedH,255-computedS,255-computedV};
        }
    
    private void sk(){
		// обработка клавиш
        int sp=1;
        int gac=getGameAction(k);
        switch(gac){
            case LEFT: if(frame==0){
                if(in==0&&r>=sp)
                    r-=sp;
                else if(in==1&&gr>=sp)
                    gr-=sp;
                else if(in==2&&b>=sp)
                    b-=sp;
            }
            else{
                if(in==0){
                    if((H-=5)<0)
                        H=360;}
                else if(in==1){if(x>=1)x-=1;}
            } break;
            case RIGHT: if(frame==0){
                if(in==0&&r<=254)
                    r+=sp;
                else if(in==1&&gr<=254)
                    gr+=sp;
                else if(in==2&&b<=254)
                    b+=sp;}
            else {
                if(in==0){
                    if((H+=5)>360)
                        H=0;}
                else if(in==1){if(x<127)x+=1;}
            }break;}
        switch(k){
            case 56: if(in==1&&frame==1){
                if(y<127)y+=1;
            }break;
            case 50: if(in==1&&frame==1){
                if(y>=1)y-=1;
            }
        }
    }
    
    public void setColor(int c){
        r=c>>16&0xff;
        gr=c>>8&0xff;
        b=c&0xff;
        if(frame==1){
            float[] data=RGBtoHSV(r,gr,b); H=data[0]; x=(int)(data[1]*128/255); y=(int)(data[2]*128/255); upData();
        }
    }

    /**
     * Called when a key is pressed.
     */
    protected void keyPressed(int key) {
        if((key==50||key==56||key==52||key==54)&&frame==1&&in==1)k=key;
        int sp=5;
        String strCode = null;
    try {
      strCode = getKeyName(key).toLowerCase();
    }
    catch (IllegalArgumentException e) {
    }
    if (strCode != null)
    {
      if (((("soft1".equals(strCode)) || ("soft 1".equals(strCode)) || ("soft_1".equals(strCode)) || ("softkey 1".equals(strCode)) || ("sk2(left)".equals(strCode)) || (strCode.startsWith("left soft"))))){
          if(frame==0){frame=1; float[] data=RGBtoHSV(r,gr,b); H=data[0]; x=(int)(data[1]*128/255); y=(int)(data[2]*128/255); upData(); } else{ frame=0; setColor(colordata[y*128+x]); } in=0; return;}  //left
      if (("soft2".equals(strCode)) || ("soft 2".equals(strCode)) || ("soft_2".equals(strCode)) || ("softkey 4".equals(strCode)) || ("sk1(right)".equals(strCode)) || (strCode.startsWith("right soft"))){
        returnColor(); return;}//right
    }
     switch (key)
    {
    case -202:
    case -21:
    case -6:
    case 21:
    case 105:
    case 113:
    case 57345:
        if(frame==0){frame=1; float[] data=RGBtoHSV(r,gr,b); H=data[0]; x=(int)(data[1]*128/255); y=(int)(data[2]*128/255); upData(); } else{ frame=0; setColor(colordata[y*128+x]); } in=0; break;//left
    case -203:
    case -22:
    case -7:
    case 22:
    case 106:
    case 112:
    case 57346:
      returnColor();break;//right
    }
        int ga=getGameAction(key);
        switch(ga){
            case LEFT: if(in==-1&&frame==1){frame=0;break;}if(frame==0){
                if(in==0&&r>=sp)
                    r-=sp;
                else if(in==1&&gr>=sp)
                    gr-=sp;
                else if(in==2&&b>=sp)
                    b-=sp;
            }
            else{
                if(in==0){
                    if((H-=sp)<0)
                        H=360;}
                else if(in==1){}
            } break;
            case RIGHT: if(in==-1&&frame==0){frame=1;break;}
                if(frame==0){
                    if(in==0&&r<=254)
                       r+=sp;
                 else if(in==1&&gr<=254)
                        gr+=sp;
                 else if(in==2&&b<=254)
                       b+=sp;}
                else {
                    if(in==0){
                       if((H+=sp)>360)
                          H=0;}
                else if(in==1){}
            } break;
            case UP: if (in>0&&key!=50)in--;break;
            case DOWN: if(in<2&&key!=56)in++;if(frame==1&&in>1)in=1;break;
            case FIRE: returnColor();
        }
        if(key==49){frame=0; setColor(colordata[y*128+x]); in=0; }
        else if(key==51){frame=1; float[] data=RGBtoHSV(r,gr,b); H=data[0]; x=(int)(data[1]*128/255); y=(int)(data[2]*128/255); in=0; }
    }
    
    private void returnColor(){
		// возвращаем выбранный цвет в соответствующие места
        int rl;
        if(frame==0)
            rl=r<<16|gr<<8|b;
        else rl=colordata[y*128+x];
        switch(mode){
                case 0: Main.main.e.color=rl;break;
                case 1: Statics.edBack=rl;Main.main.e.clearBuffers();break;
                case 2: Statics.curColor=rl;break;
                case 3: Statics.gridColor=rl;break;
                case 4: Statics.menuBack=rl;break;
                case 5: Statics.textColor=rl;break;
                case 6: Statics.menuTextColor=rl;Main.main.menu.menu.textColor=rl;break;
                case 7: Statics.background=rl;break;
        }
        if(mode==0||mode==7)Main.main.toEditor(); else Main.main.toMenu();
        
    }

    /**
     * Called when a key is released.
     */
    protected void keyReleased(int keyCode) {
        k=0;
    }

    /**
     * Called when a key is repeated (held down).
     */
    protected void keyRepeated(int keyCode) {
        k=keyCode;
    }

    /**
     * Called when the pointer is dragged.
     */
    protected void pointerDragged(int xp, int yp) {
        if(frame==0){
        if(xp>=5&&yp>=sh+5&&xp<=ww/2+5&&yp<=25+sh){
            r=(xp-5)*255/(ww/2);
        }
        if(xp>=15&&yp>=sh+30&&xp<=ww/2+15&&yp<=sh+50){
            gr=(xp-15)*255/(ww/2);
        }
        if(xp>=25&&yp>=sh+55&&xp<=ww/2+25&&yp<=sh+75){
            b=(xp-25)*255/(ww/2);
        }
        if(xp>=5&&yp>=sh+90&&xp<=ww-5&&yp<=sh+115){
            frame=1;
           float[] data=RGBtoHSV(r,gr,b);
           H=data[0];
           x=(int)(data[1]*128/255);
           y=(int)(data[2]*128/255);
        }
        }
        else if(frame==1){
            if(xp>=3&&xp<=ww-3&&yp>=sh+6&&yp<=sh+24){
                H=(xp-3)*360/(ww-3);
                if(H>=360)H=0;
                if(H<0)H=360;
                upData();
            }
            else if(xp>=16&&yp>=sh+39&&xp<=144&&yp<=sh+167){
                x=(xp-16);
                y=yp-sh-39;
            }
        }
    }

    /**
     * Called when the pointer is pressed.
     */
    protected void pointerPressed(int xp, int yp) {
        if(yp>=hh-40){
            if(xp<=ww/4){
       if(frame==0){
           frame=1;
           float[] data=RGBtoHSV(r,gr,b);
           H=data[0];
           x=(int)(data[1]*128/255);
           y=(int)(data[2]*128/255);}
       else{
           frame=0;
           setColor(colordata[y*128+x]);
       }
            }
            else if(xp>=ww-ww/4){
                returnColor();
            }
    }
        if(frame==0){
        if(xp>=5&&yp>=sh+5&&xp<=ww/2+5&&yp<=25+sh){
            r=(xp-5)*255/(ww/2);
        }
        if(xp>=15&&yp>=sh+30&&xp<=ww/2+15&&yp<=sh+50){
            gr=(xp-15)*255/(ww/2);
        }
        if(xp>=25&&yp>=sh+55&&xp<=ww/2+25&&yp<=sh+75){
            b=(xp-25)*255/(ww/2);
        }
        if(xp>=5&&yp>=sh+90&&xp<=ww-5&&yp<=sh+115){
            frame=1;
           float[] data=RGBtoHSV(r,gr,b);
           H=data[0];
           x=(int)(data[1]*128/255);
           y=(int)(data[2]*128/255);
        }
        }
        else if(frame==1){
            if(xp>=3&&xp<=ww-3&&yp>=sh+6&&yp<=sh+24){
                H=(xp-3)*360/(ww-3);
                if(H>=360)H=0;
                if(H<0)H=360;
                upData();
            }
            else if(xp>=16&&yp>=sh+39&&xp<=144&&yp<=sh+167){
                x=(xp-16);
                y=yp-sh-39;
            }
        }
    }

    /**
     * Called when the pointer is released.
     */
    protected void pointerReleased(int x, int y) {
    }
    
}
