/*
 * Это окно редактирования, ну то, что открывается по нажатию на клавишу 9.
 */

/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */

import javax.microedition.lcdui.*;

/**
 * @author Shaman
 */
public class Edit extends Canvas{
    int w,h,md,xs,ys,cx,cy,tn; // md - текущее меню
    public static int mo; // текущий режим. 0 - объекты, 1 - полигоны, 2 - вершины.
    Menu m;
    Image modes,tex;
    Triangle sel;
    int selv=0;
    boolean mv=false;
    Font f;
    int sh;
    

    /**
     * constructor
     */
    public Edit() {
    setFullScreenMode(true); 
    m = new Menu(null, Statics.font);
    w=getWidth();
    h=getHeight();
    f=Statics.font;
    sh=f.getHeight();
    try{
        modes=Image.createImage("/img/"+(Statics.bigImages?"60":"30")+"/modes.png");
    }catch(Exception e){}
    toEdit();
    }

    /**
     * paint
     */
    public void paint(Graphics g) {
        g.setColor(Statics.menuBack);
    g.fillRect(0, 0, w, h);
    if(md!=1){ // если мы в обычном меню
    m.paint(g, 0, h/3, w, h, 1);
    g.setColor(0x888888);
    g.fillRoundRect(w/2-modes.getWidth()/2+mo*(Statics.bigImages?66:33), h/3-(Statics.bigImages?60:30)-modes.getHeight()/2, (Statics.bigImages?60:30), (Statics.bigImages?60:30), 15, 15);
    //g.setColor(0x333333);
    //g.drawRoundRect(w/2-modes.getWidth()/2+mo*33, h/3-30-modes.getHeight()/2, 31, 31, 20, 20);
    g.setColor(0xbbbbbb);
    g.drawRoundRect(w/2-modes.getWidth()/2+mo*(Statics.bigImages?66:33)-1, h/3-(Statics.bigImages?60:30)-modes.getHeight()/2-1, (Statics.bigImages?62:31), (Statics.bigImages?62:31), 15, 15);
    g.setColor(0x888888);
    g.drawRoundRect(w/2-modes.getWidth()/2+mo*(Statics.bigImages?66:33), h/3-(Statics.bigImages?60:30)-modes.getHeight()/2, (Statics.bigImages?60:30), (Statics.bigImages?60:30), 15, 15);
    g.drawImage(modes, w/2, h/3-modes.getHeight(), 3);
    drawLeftSoft(g,Statics.russian?"Назад":"Back");
    drawRightSoft(g,Statics.russian?"Выбрать":"Select");
    }
    else{ // или если в режиме редактирования UV-координат для вершин
        g.setColor(0);
        g.drawRect(5, 5, w-10, h-50);
        if(tex!=null)g.drawImage(tex, 5, 5, 20);
        if(mo==1&&Editor.sel2!=null){
            for(int i=0;i<Editor.sel2.size();i++){
                Triangle t=(Triangle)Editor.sel2.elementAt(i);
                if(t.uv==null)t.uv=new float[6];
                if(sel!=null&&sel==t)g.setColor(229,106,156); else g.setColor(106,229,156);
                g.drawLine((int)(t.uv[0]*(w-10)+5), (int)(t.uv[1]*(h-50)+5), (int)(t.uv[2]*(w-10)+5), (int)(t.uv[3]*(h-50)+5));
                g.drawLine((int)(t.uv[0]*(w-10)+5), (int)(t.uv[1]*(h-50)+5), (int)(t.uv[4]*(w-10)+5), (int)(t.uv[5]*(h-50)+5));
                g.drawLine((int)(t.uv[2]*(w-10)+5), (int)(t.uv[3]*(h-50)+5), (int)(t.uv[4]*(w-10)+5), (int)(t.uv[5]*(h-50)+5));
                if(sel!=null&&selv==1)g.setColor(0xaa0000); else g.setColor(0x99);
                g.fillRect((int)(t.uv[0]*(w-10)), (int)(t.uv[1]*(h-50)),10,10);
                if(sel!=null&&selv==2)g.setColor(0xaa0000); else g.setColor(0x99);
                g.fillRect((int)(t.uv[2]*(w-10)), (int)(t.uv[3]*(h-50)),10,10);
                if(sel!=null&&selv==3)g.setColor(0xaa0000); else g.setColor(0x99);
                g.fillRect((int)(t.uv[4]*(w-10)), (int)(t.uv[5]*(h-50)),10,10);
            }
        }
            if(!Statics.touch){
                g.setColor(0xff0000);
            g.fillArc(cx-5, cy-5, 20, 20, 0, 360);
            }
            g.setColor(0);
            int ld=Statics.font.stringWidth("Ok")+5;
            g.drawRect(ld, h-40, w-ld-10, 40);
            g.drawLine((w-ld-10)/2+ld, h-40,(w-ld-10)/2+ld, h-1);
            g.drawString("<", (w-ld-10)/4+ld, h-25, Graphics.TOP|Graphics.HCENTER);
            g.drawString(">", w-(w-ld-10)/4, h-25, Graphics.TOP|Graphics.HCENTER);
            drawLeftSoft(g,"Ok");
    }
    repaint();
    }
    
    private void toEdit(){
        md=0;
        if(mo!=1)m.setElems(new String[]{Statics.russian?"Свойства":"Properties",Statics.russian?"UV-координаты":"UV-coord",Statics.russian?"Нормали":"Normals",Statics.russian?"Сглаживание":"Smooth",Statics.russian?"Пробный материал":"Test material",Statics.russian?"Удалить материал":"Delete material",Statics.russian?"Удалить":"Delete"});
        else m.setElems(new String[]{Statics.russian?"Свойства":"Properties",Statics.russian?"UV-координаты":"UV-coord",Statics.russian?"Нормали":"Normals",Statics.russian?"Сглаживание":"Smooth",Statics.russian?"Пробный материал":"Test material",Statics.russian?"Удалить материал":"Delete material",Statics.russian?"Удалить":"Delete",Statics.russian?"Отделить":"Detach"});
    }
    
    private void toUV(){
        if(mo==1){
            md=1;
            mv=false;
            sel=null;
        }
    }
    
    private void toNormals(){
        md=2;
        m.setElems(new String[]{Statics.russian?"Обратить":"Inverse",Statics.russian?"Пересчитать":"Recalculate"});
    }
    
    private void toSmooth(){
        md=3;
        m.setElems(new String[]{Statics.russian?"Вкл":"On",Statics.russian?"Выкл":"Off"});
    }

    /**
     * Called when a key is pressed.
     */
    protected void keyPressed(int key) {
        int ga=getGameAction(key);
        switch(ga){
            case UP: if(md==1){ if(mv)move(0,-5); else if(cy>=5)cy-=5; } else m.up();break;
            case DOWN: if(md==1){ if(mv)move(0,5); else if(cy<=h-55)cy+=5; } else m.down();break;
            case RIGHT:if(md==1){ if(mv)move(5,0); else if(cx<=w-15)cx+=5; } else if(mo<2){mo++;
                toEdit();}break;
            case LEFT:if(md==1){ if(mv)move(-5,0); else if(cx>=5)cx-=5; } else if(mo>0){mo--;
                toEdit();}break;
            case FIRE: if(md==1){
                if(!mv){
                select(cx,cy);
                }
                else mv=false;
            } else fire();break;
        }
        String strCode = null;
    try {
      strCode = getKeyName(key).toLowerCase();
    }
    catch (IllegalArgumentException e) {
    }
    if (strCode != null)
    {
      if (((("soft1".equals(strCode)) || ("soft 1".equals(strCode)) || ("soft_1".equals(strCode)) || ("softkey 1".equals(strCode)) || ("sk2(left)".equals(strCode)) || (strCode.startsWith("left soft")))))
      { back(); return;}//left
      if (("soft2".equals(strCode)) || ("soft 2".equals(strCode)) || ("soft_2".equals(strCode)) || ("softkey 4".equals(strCode)) || ("sk1(right)".equals(strCode)) || (strCode.startsWith("right soft")))
      {fire();return; }//right
    }
     switch (key)
    {
    case -202:
    case -21:
    case -6:
    case 21:
    case 105:
    case 113:
    case 57345:
        back();break;//left
    case -203:
    case -22:
    case -7:
    case 22:
    case 106:
    case 112:
    case 57346:
      fire();break;//right
    }
     if(md==1){
         if(key==KEY_STAR){
             tn--;
             if(tn<0){if(MaterialEditor.mat!=null&&!MaterialEditor.mat.isEmpty())tn=MaterialEditor.mat.size(); else tn=0; }
             updImg();
         }
         if(key==KEY_POUND){
             if(MaterialEditor.mat!=null&&!MaterialEditor.mat.isEmpty()){
             tn++;
             if(tn>MaterialEditor.mat.size())tn=0;
             }
             updImg();
         }
     }
    }
    
    private void updImg(){
		// обновление заднего изображения из доступных текстур в редакторе материалов
        if(tn==0||MaterialEditor.mat==null||tn>MaterialEditor.mat.size()){
            tex=null;
            return;}
        Material mat=(Material)MaterialEditor.mat.elementAt(tn-1);
        if(mat.texture==null){tex=null;return; }
        tex=Main.resizeImage(Image.createRGBImage(mat.texture, mat.w, mat.h, false), w-10, h-50);
    }
    
        private void drawLeftSoft(Graphics g,String s){
        if(!Statics.touch){
        g.setColor(8947967);
        g.fillRoundRect(0, h - sh+1, g.getFont().stringWidth(s)+5, sh-1,10,10);
        g.setColor(0);
        g.drawRoundRect(0, h - sh+1, g.getFont().stringWidth(s)+5, sh-2,10,10);
        g.setColor(0x555555);
        g.drawString(s, 2, h - 2, 36);
        g.setColor(Statics.textColor);
        g.drawString(s, 3, h - 1, 36);}
        else{
            g.setColor(8947967);
        g.fillRoundRect(0, h - 40, g.getFont().stringWidth(s)+5, 39,15,15);
        g.setColor(0);
        g.drawRoundRect(0, h - 40, g.getFont().stringWidth(s)+5, 38,15,15);
        g.setColor(0x555555);
        g.drawString(s, 2, h + sh/2 - 20, 36);
        g.setColor(Statics.textColor);
        g.drawString(s, 3, h +sh/2 - 19, 36);
        }
    }
    
    private void drawRightSoft(Graphics g,String s){
        if(!Statics.touch){
        g.setColor(8947967);
        g.fillRoundRect(w-g.getFont().stringWidth(s)-5, h - sh + 1, g.getFont().stringWidth(s)+5, sh-1,10,10);
        g.setColor(0);
        g.drawRoundRect(w-g.getFont().stringWidth(s)-5, h - sh + 1, g.getFont().stringWidth(s)+4, sh-2,10,10);
        g.setColor(0x555555);
        g.drawString(s, w - 4, h - 2, 40);
        g.setColor(Statics.textColor);
        g.drawString(s, w - 3, h - 1, 40);}
        else{
            g.setColor(8947967);
            g.fillRoundRect(w-g.getFont().stringWidth(s)-5, h - 40, g.getFont().stringWidth(s)+5, 39,15,15);
            g.setColor(0);
        g.drawRoundRect(w-g.getFont().stringWidth(s)-5, h-40, g.getFont().stringWidth(s)+4, 38,15,15);
        g.setColor(0x555555);
        g.drawString(s, w - 4, h+sh/2- 20, 40);
        g.setColor(Statics.textColor);
        g.drawString(s, w - 3, h+sh/2 - 19, 40);
        }
    }
    
    private void select(int xs,int ys){ // выбор вершин при редактировании uv
        if(Editor.sel2==null||Editor.sel2.isEmpty())return;
        boolean flg=false;
        for(int i=0;i<Editor.sel2.size();i++){
            Triangle t=(Triangle)Editor.sel2.elementAt(i);
            if(xs>=t.uv[0]*(w-5)-5&&xs<=t.uv[0]*(w-5)+5&&ys>=t.uv[1]*(h-55)-5&&ys<=t.uv[1]*(h-55)+5){
                sel=t;
                selv=1;
                flg=true;
                break;
            }
            if(xs>=t.uv[2]*(w-5)-5&&xs<=t.uv[2]*(w-5)+5&&ys>=t.uv[3]*(h-55)-5&&ys<=t.uv[3]*(h-55)+5){
                sel=t;
                selv=2;
                flg=true;
                break;
            }
            if(xs>=t.uv[4]*(w-5)-5&&xs<=t.uv[4]*(w-5)+5&&ys>=t.uv[5]*(h-55)-5&&ys<=t.uv[5]*(h-55)+5){
                sel=t;
                selv=3;
                flg=true;
                break;
            }
            if(!flg){
            int ai=(int)((t.uv[0]*(w-5) - xs) * (t.uv[3]*(h-55) - t.uv[1]*(h-55)) - (t.uv[2]*(w-5) - t.uv[0]*(w-5)) * (t.uv[1]*(h-55) - ys));
                int bi=(int)((t.uv[2]*(w-5) - xs) * (t.uv[5]*(h-55) - t.uv[3]*(h-55)) - (t.uv[4]*(w-5) - t.uv[2]*(w-5)) * (t.uv[3]*(h-55) - ys));
                int ci=(int)((t.uv[4]*(w-5) - xs) * (t.uv[1]*(h-55) - t.uv[5]*(h-55)) - (t.uv[0]*(w-5) - t.uv[4]*(w-5)) * (t.uv[5]*(h-55) - ys));
             if((ai>=0&&bi>=0&&ci>=0)||(ai<=0&&bi<=0&&ci<=0)){ sel=t;
              selv=0;
                flg=true;
                break;
              }
            }
        }
        mv=flg;
    }
    
    private void move(int xs,int ys){ // двигаем UV-координаты выбранного полигона
        if(sel!=null){
         if(selv==0||selv==1){
             sel.uv[0]+=(float)(xs)/(w-5);
             sel.uv[1]+=(float)(ys)/(h-55);
         }
         if(selv==0||selv==2){
             sel.uv[2]+=(float)(xs)/(w-5);
             sel.uv[3]+=(float)(ys)/(h-55);
         }
         if(selv==0||selv==3){
             sel.uv[4]+=(float)(xs)/(w-5);
             sel.uv[5]+=(float)(ys)/(h-55);
         }
        }
    }
        
        public void fire(){ // метод при нажатии на 5 или Ок
            switch(m.index){
                case 4: Material ma=new Material();
                Image tex=null;
                try{
                    tex=Image.createImage("/img/30/tex.jpg");
                }catch(Exception e){}
                    ma.setDiffuseMap(tex);
                    ma.self=0.2f;
                    //m.opacity=200;
                    Main.main.e.m.setMaterial(ma); MaterialEditor.mat.addElement(ma); Main.main.toEditor(); break;
            case 0: if(md==2){ inverse(); Main.main.toEditor();} else if(md==3){smoothOn(); Main.main.toEditor();}
            else
            if(Editor.sel!=null&&Editor.sel.size()==1&&Editor.sel.firstElement() instanceof Group){
                Form fo=new Form(Statics.russian?"Свойства":"Properties");
            Main.main.d.setCurrent(fo);
            fo.addCommand(new Command("Ok",1,1));
                final TextField nm=new TextField(Statics.russian?"Имя:":"Name",((Group)(Editor.sel.elementAt(0))).name,50,TextField.ANY);
                fo.append(nm);
            final ChoiceGroup cg=new ChoiceGroup("",List.MULTIPLE,new String[]{Statics.russian?"Видимый":"Visible"},null);
            cg.setSelectedFlags(new boolean[]{((Group)(Editor.sel.elementAt(0))).visible});
            fo.append(cg);
            fo.append(""+((Group)(Editor.sel.elementAt(0))).f.size()+(Statics.russian?" полигонов":" triangles"));
            fo.append(""+((Group)(Editor.sel.elementAt(0))).v.size()+(Statics.russian?" вершин":" vertexes"));
                fo.setCommandListener(new CommandListener(){
                public void commandAction(Command c,Displayable dis){
                    ((Group)(Editor.sel.elementAt(0))).name=nm.getString();
                ((Group)(Editor.sel.elementAt(0))).visible=cg.isSelected(0);
                Main.main.toEdit();
                }
                });
                    } break;
            case 1: if(md==0)toUV(); else if(md==2){recalculateNormals(); Main.main.toEditor();} else if(md==3){smoothOff(); Main.main.toEditor();} break;
            case 2: toNormals(); break;
            case 3: toSmooth(); break;
            case 5: deleteMaterial(); Main.main.toEditor(); break;
            case 6: if(mo==0&&Editor.sel!=null){
                for(int i=0;i<Editor.sel.size();i++){
                    if(Editor.sel.elementAt(i) instanceof Light)
                        Main.main.e.m.deleteLight((Light)Editor.sel.elementAt(i));
                   else Main.main.e.m.g.removeElement(Editor.sel.elementAt(i));
                }
            }
            else if(mo==1&&Editor.sel2!=null){
                for(int i=0;i<Editor.sel2.size();i++)
                    Main.main.e.m.deleteFace((Face)Editor.sel2.elementAt(i));
            }
            else if(mo==2&&Editor.sel3!=null){
                for(int i=0;i<Editor.sel3.size();i++)
                    Main.main.e.m.deleteVertex((Vertex)Editor.sel3.elementAt(i));
            }
                Editor.sel=null;
                Editor.sel2=null;
                Editor.sel3=null;
                System.gc();
                Main.main.toEditor();
                break;
            case 7: if(Editor.sel2==null)break;
                Group gr=new Group();
                gr.name="Object_"+Main.main.e.m.g.size();
                for(int i=0;i<Editor.sel2.size();i++){
                    Triangle tr=(Triangle)Editor.sel2.elementAt(i);
                Main.main.e.m.deleteFace(tr);
                tr.a=new Vertex(tr.a);
                tr.b=new Vertex(tr.b);
                tr.c=new Vertex(tr.c);
                gr.add(tr);
                }
                gr.countBoundary();
                Main.main.e.m.add(gr);
                //Editor.sel2=null;
                Main.main.toEditor();
                break;
                }
        }
        
        private void back(){ // назад
            if(md==0) Main.main.toEditor();
            else toEdit();
        }
        
        private void deleteMaterial(){ // удаляем материал с выбранных объектов или полигонов
            if(mo==0&&Editor.sel!=null){
                for(int i=0;i<Editor.sel.size();i++){
                    if(!(Editor.sel.elementAt(i) instanceof Group))continue;
                    Group gr=(Group)Editor.sel.elementAt(i);
                    for(int j=0;j<gr.f.size();j++)
                        ((Triangle)gr.f.elementAt(j)).material=null;
                        }
            }
            else if(mo==1&&Editor.sel2!=null){
                for(int i=0;i<Editor.sel2.size();i++)
                    ((Triangle)Editor.sel2.elementAt(i)).material=null;
            }
        }
        
        private void inverse(){ // обращение нормалей, у полигонов свои нормали, у вершин свои, но рассчитываемые из полигонных (это для сглаживания освещения).
            if(mo==0&&Editor.sel!=null){
                for(int i=0;i<Editor.sel.size();i++){
                    if(!(Editor.sel.elementAt(i) instanceof Group))continue;
                    Group gr=(Group)Editor.sel.elementAt(i);
                    for(int j=0;j<gr.f.size();j++)
                        ((Triangle)gr.f.elementAt(j)).invert();
                }
            }
            else if(mo==1&&Editor.sel2!=null){
                for(int i=0;i<Editor.sel2.size();i++){
                    ((Triangle)Editor.sel2.elementAt(i)).invert();
                }
            }
            else if(mo==3&&Editor.sel3!=null){
                for(int i=0;i<Editor.sel3.size();i++){
                    Vertex ver=((Vertex)Editor.sel2.elementAt(i));
                    ver.nx=-ver.nx;
                    ver.ny=-ver.ny;
                    ver.nz=-ver.nz;
                }
            }
        }
        private void recalculateNormals(){ // пересчет нормалей
            if(mo==0&&Editor.sel!=null){
                for(int i=0;i<Editor.sel.size();i++){
                    if(!(Editor.sel.elementAt(i) instanceof Group))continue;
                    Group gr=(Group)Editor.sel.elementAt(i);
                    gr.triNorm();
                    gr.verNorm();
                }
            }
            else if(mo==1&&Editor.sel2!=null){
                for(int i=0;i<Editor.sel2.size();i++){
                    ((Triangle)Editor.sel2.elementAt(i)).norm();
            }
            }
            else if(mo==2&&Editor.sel3!=null){
                for(int i=0;i<Editor.sel3.size();i++){
                    Vertex ver=(Vertex)Editor.sel3.elementAt(i);
                    Main.main.e.m.vertexNorm(ver);
                }
            }
        }
        private void smoothOn(){ // включение сглажвания между полигонами при освещении
            if(mo==0&&Editor.sel!=null){
                for(int i=0;i<Editor.sel.size();i++){
                    if(!(Editor.sel.elementAt(i) instanceof Group))continue;
                    Group gr=(Group)Editor.sel.elementAt(i);
                    for(int j=0;j<gr.f.size();j++){
                        ((Triangle)gr.f.elementAt(j)).smooth=true;
                    }
                }
            }
            else if(mo==1&&Editor.sel2!=null){
                for(int i=0;i<Editor.sel2.size();i++){
                    ((Triangle)Editor.sel2.elementAt(i)).smooth=true;
                }
            }
        }
        private void smoothOff(){ // выключение
            if(mo==0&&Editor.sel!=null){
                for(int i=0;i<Editor.sel.size();i++){
                    if(!(Editor.sel.elementAt(i) instanceof Group))continue;
                    Group gr=(Group)Editor.sel.elementAt(i);
                    for(int j=0;j<gr.f.size();j++){
                        ((Triangle)gr.f.elementAt(j)).smooth=false;
                    }
                }
            }
            else if(mo==1&&Editor.sel2!=null){
                for(int i=0;i<Editor.sel2.size();i++){
                    ((Triangle)Editor.sel2.elementAt(i)).smooth=false;
                }
            }
        }

    /**
     * Called when a key is released.
     */
    protected void keyReleased(int keyCode) {
    }

    /**
     * Called when a key is repeated (held down).
     */
    protected void keyRepeated(int keyCode) {
        if(md==1){
            switch(getGameAction(keyCode)){
                case UP: if(mv)move(0,-5); else if(cy>=5)cy-=5;break;
            case DOWN: if(mv)move(0,5); else if(cy<=h-55)cy+=5;break;
            case RIGHT:if(mv)move(5,0); else if(cx<=w-15)cx+=5;break;
            case LEFT:if(mv)move(-5,0); else if(cx>=5)cx-=5;break;
            }
        }
    }

    /**
     * Called when the pointer is dragged.
     */
    protected void pointerDragged(int x, int y) {
        if(md==1&&mv){
            move(x-xs,y-ys);
            xs=x;
            ys=y;
        }
    }

    /**
     * Called when the pointer is pressed.
     */
    protected void pointerPressed(int xp, int yp) {
        if(yp>=h-40){
            if(xp<=w/4){
                if(md>=1&&md<=3)toEdit(); else Main.main.toEditor();
            }
            else if(xp>=w-w/4){
                if(md!=1)fire();
            }
        }
        if(md!=1){
        if(yp>h/3-modes.getHeight()/2){
            int ti=m.getTouchIndex(yp);
            if(ti!=0xffffff){
                m.index=ti;
                repaint();
                fire();
            }
        }
        if(yp<=h/3-modes.getHeight()/2){
            if(xp-((w-modes.getWidth())/2)<=modes.getWidth()/3){
                mo=0;
                toEdit();
            }
            else if(xp-((w-modes.getWidth())/2)<=modes.getWidth()*2/3){
                mo=1;
                toEdit();
            }
            else if(xp-((w-modes.getWidth())/2)<=modes.getWidth()){
                mo=2;
                toEdit();
            }
        }
        }
        else{
            int ld=Statics.font.stringWidth("Ok")+5;
            if(xp>w-(w-ld-5)/2-5&&yp>=h-40){
             tn--;
             if(tn<0){if(MaterialEditor.mat!=null&&!MaterialEditor.mat.isEmpty())tn=MaterialEditor.mat.size(); else tn=0; }
             updImg();
            }
            else if(xp>ld+(w-ld-5)/2&&yp>=h-40){
                if(MaterialEditor.mat!=null&&!MaterialEditor.mat.isEmpty()){
             tn++;
             if(tn>MaterialEditor.mat.size())tn=0;
             }
             updImg();
            }
            else{
            xs=xp;
            ys=yp;
            select(xp,yp);
            }
        }
    }

    /**
     * Called when the pointer is released.
     */
    protected void pointerReleased(int x, int y) {
        if(md==1)
            mv=false;
    }
}
