import javax.microedition.lcdui.Graphics;

public class Line extends Face
{
  public Vertex a;
  public Vertex b;

  public Line(Vertex v1, Vertex v2, int col)
  {
    a = v1;
    b = v2;
    color = col;}

  public int getS() {
    return ((a.zc + b.zc) / 2); }

  public void paint(Graphics g) {
    paint(g, color); }
  
    public void setVertexMatrix(Matrix3D m) {
    a.setMatrix(m);
    b.setMatrix(m);
  }
  
  public void render(int r[],int z[]){
      if(a.zc<-Vertex.dist&&b.zc<-Vertex.dist) return;
      if(a.zc>Statics.limit&&b.zc>Statics.limit) return;
      if(a.zc<-Vertex.dist){
          int xc=a.xc + (b.xc - a.xc) * (-Vertex.dist - a.zc) / (b.zc - a.zc);
          int yc=a.yc + (b.yc - a.yc) * (-Vertex.dist - a.zc) / (b.zc - a.zc);
          a.xc=xc;
          a.yc=yc;
          a.zc=-Vertex.dist+1;
            a.to2d();
      }
      if(b.zc<-Vertex.dist){
          int xc=b.xc + (a.xc - b.xc) * (-Vertex.dist+1 - b.zc) / (a.zc - b.zc);
          int yc=b.yc + (a.yc - b.yc) * (-Vertex.dist+1 - b.zc) / (a.zc - b.zc);
          b.xc=xc;
          b.yc=yc;
          b.zc=-Vertex.dist+1;
          b.to2d();
      }
      if(a.sx<0&&b.sx<0)return;
      if(a.sy<0&&b.sy<0)return;
      if(a.sx>Statics.w&&b.sx>Statics.w)return;
      if(a.sy>Statics.h&&b.sy>Statics.h)return;
  drawLine(r,a.sx,a.sy,b.sx,b.sy,color);
  }
  
  public void render(int[] r,int[] z,int v){
      double scale=0;
      if(v!=0){
      scale=(double)Main.main.e.dist;
        if(scale>0)scale=scale/10000+0.1;
        else if(scale==0)scale=0.1;
        else scale=0.1+scale/100000;}
      if(v==0)render(r,z);
      else if(v==1){
          int x0=Main.main.e.xo;
      int z0=Main.main.e.zo;
      drawLine(r,(int)(Statics.w/2+a.x*scale+x0*scale),(int)(Statics.h/2-a.z*scale-z0*scale),(int)(Statics.w/2+x0*scale+b.x*scale),(int)(Statics.h/2-b.z*scale-z0*scale),color);}
      else if(v==2){
           int y0=Main.main.e.yo;
      int z0=Main.main.e.zo;
      drawLine(r,(int)(Statics.w/2+z0*scale+a.z*scale),(int)(Statics.h/2-y0*scale-a.y*scale),(int)(Statics.w/2+z0*scale+b.z*scale),(int)(Statics.h/2-y0*scale-b.y*scale),color);
      }
      else if(v==3){
          int y0=Main.main.e.yo;
      int x0=Main.main.e.xo;
      drawLine(r,(int)(Statics.w/2+x0*scale+a.x*scale),(int)(Statics.h/2-y0*scale-a.y*scale),(int)(Statics.w/2+x0*scale+b.x*scale),(int)(Statics.h/2-y0*scale-b.y*scale),color);
      }
  }

  public void paint(Graphics g, int col) {
      if(a.zc<-Vertex.dist&&b.zc<-Vertex.dist) return;
      if(a.zc>Statics.limit&&b.zc>Statics.limit) return;
      if(a.zc<-Vertex.dist){
          int xc=a.xc + (b.xc - a.xc) * (-Vertex.dist - a.zc) / (b.zc - a.zc);
          int yc=a.yc + (b.yc - a.yc) * (-Vertex.dist - a.zc) / (b.zc - a.zc);
          a.xc=xc;
          a.yc=yc;
          a.zc=-Vertex.dist+1;
            a.to2d();
      }
      if(b.zc<-Vertex.dist){
          int xc=b.xc + (a.xc - b.xc) * (-Vertex.dist+1 - b.zc) / (a.zc - b.zc);
          int yc=b.yc + (a.yc - b.yc) * (-Vertex.dist+1 - b.zc) / (a.zc - b.zc);
          b.xc=xc;
          b.yc=yc;
          b.zc=-Vertex.dist+1;
          b.to2d();
      }
      if(a.sx<0&&b.sx<0)return;
      if(a.sy<0&&b.sy<0)return;
      if(a.sx>Statics.w&&b.sx>Statics.w)return;
      if(a.sy>Statics.h&&b.sy>Statics.h)return;
    g.setColor(col);
    g.drawLine(a.sx, a.sy, b.sx, b.sy);
  }
}