// главкласс, стартАпп. Инициализация, смена окон и настройки

import java.io.*;
import javax.microedition.io.*;
import javax.microedition.io.file.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;
import javax.microedition.rms.RecordStore;

public class Main extends MIDlet
{
  Display d;
  MainMenu menu;
  Editor e;
  Edit edit;
  Color color;
  MaterialEditor me;
  StartWindow st;
  FileMan fm;
  public static Main main;

  public void startApp()
  {
    main = this;
    d = Display.getDisplay(this);
    if(!openSet())toMenu();
    else{
    st=new StartWindow();
    d.setCurrent(st);}
  }

  public void newEditor() {
      if(e!=null){
      e.m=null;
      e.n=null;
      e.zb=null;
      e.rgb=null;
      e.zb2=null;
      e.rgb2=null;
      e.ver1=e.ver2=e.cur=null;
      e.modes=null;
      e.instrs=null;
      e.instr=null;
      e.innames=null;
      e.buf=null;
      e.gr=null;
      Edit.mo=0;
      Statics.background=0;
      Statics.pers=300;
      Statics.limit=20000;
      e.sel=null;
      e.sel2=null;
      e.sel3=null;
      e=null;
      MaterialEditor.mat=null;
      }
      System.gc();
      MaterialEditor.mat=new java.util.Vector();
    e = new Editor();
  }

  public void toEditor() {
      if(e==null)newEditor();
      e.resetTimer();
      e.render();
      e.draw();
    d.setCurrent(e); menu=null;edit=null;color=null;me=null;fm=null;System.gc();}

  public void toMenu() {
      if(menu==null){menu=new MainMenu();
    menu.toMenu();}
    d.setCurrent(menu);
    color=null;
    st=null;
    fm=null;
  }
  
  public void toMatEd(){
      me=new MaterialEditor();
      d.setCurrent(me);
  }
  
  public void toEdit(){
      edit=new Edit();
      d.setCurrent(edit);
  }
  public void toOpen(){
      fm=new FileMan(0);
      d.setCurrent(fm);
  }
  
  public void toSave(){
      fm=new FileMan(1);
      d.setCurrent(fm);
  }
  
  public void toSaveRender(){
      fm=new FileMan(3);
      fm.imgtosave=Image.createRGBImage(e.rgb, Statics.w, Statics.h, false);
      d.setCurrent(fm);
  }
  
  public void toOpenMap(){
      fm=new FileMan(2);
      d.setCurrent(fm);
  }
  
  public void toColor(){
      color=new Color();
      d.setCurrent(color);
  }
  
  public void setColor(int mode){
      int fcol=0;
      switch(mode){
          case 1: fcol=Statics.edBack;break;
          case 2: fcol=Statics.curColor;break;
          case 3: fcol=Statics.gridColor;break;
          case 4: fcol=Statics.menuBack;break;
          case 5: fcol=Statics.textColor;break;
          case 6: fcol=Statics.menuTextColor;break;
          case 7: fcol=Statics.background;break;
      }
      color=new Color();
      d.setCurrent(color);
      color.mode=mode;
      color.setColor(fcol);
  }
  
  public void resetView(){
      e.x=20;
      e.y=40;
      e.z=0;
      e.xo=0;
      e.yo=0;
      e.zo=0;
      e.dist=0;
      e.shading=1;
      e.act=0;
      e.view=0;
      toEditor();
  }
  public void saveScreen(final Image i){
      final TextBox tf=new TextBox("saving screenshot","file:///E:/1.gif",1000,TextField.ANY);
      d.setCurrent(tf);
      tf.addCommand(new Command("Ok",Command.OK,1));
      tf.setCommandListener(new CommandListener() {
          public void commandAction(Command c,Displayable dis){
              try{
                  FileConnection fc=(FileConnection)Connector.open(tf.getString(),Connector.READ_WRITE);
                  if(fc.exists()){
                      fc.close();
                      fc=(FileConnection)Connector.open(tf.getString()+".gif",Connector.READ_WRITE);
                  }
                  fc.create();
                  OutputStream os=fc.openOutputStream();
              Lib_gif.init(100);
              Lib_gif.add_frame(i);
              Lib_gif.close(os);
              if(os!=null){os.close();os=null;}
              if(fc!=null){fc.close();fc=null;}
              toEditor();
              }catch(Exception e){
                  Form ferr=new Form("error!");
                  ferr.append(e.getMessage()+"; "+e.toString());
                  ferr.addCommand(new Command("okay",Command.OK,1));
                  d.setCurrent(ferr);
                  ferr.setCommandListener(new CommandListener(){
                  public void commandAction(Command c,Displayable dis){
                  toEditor();
                  }
                  });
              }
          }
      });
  }

  public void pauseApp() {
  }

  public void destroyApp(boolean unconditional) {
      saveSet();
    notifyDestroyed();
  }
  
  public boolean openSet(){
      String rsname="S3DEditor 0.6";
      RecordStore rs;
try{
rs=RecordStore.openRecordStore(rsname,true);
if(rs.getNumRecords()==0)return true;
}catch(Exception e){ rs=null; return true;
}
if(rs!=null){
try{
    if(rs.getRecord(1)==null)return true;
DataInputStream dis=new DataInputStream(new ByteArrayInputStream(rs.getRecord(1)));
//Main.main.isFirst=dis.readBoolean();
Statics.russian=dis.readBoolean();
Statics.grid=dis.readBoolean();
Statics.extraBuffers=dis.readBoolean();
Statics.bigImages=dis.readBoolean();
Statics.touch=dis.readBoolean();
Statics.randColor=dis.readBoolean();
Statics.limit=dis.readInt();
Statics.pers=dis.readInt();
Statics.menuBack=dis.readInt();
Statics.edBack=dis.readInt();
Statics.curColor=dis.readInt();
Statics.textColor=dis.readInt();
Statics.gridColor=dis.readInt();
Statics.menuTextColor=dis.readInt();
Statics.background=dis.readInt();
Statics.font=Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_BOLD, dis.readInt());
dis.close();
rs.closeRecordStore();
}catch(Exception e2){return true; }
}
return false;
}
  
  public void saveSet(){
      RecordStore rs=null;
      String rsname="S3DEditor 0.6";
byte[] options=null;
try{
    rs=RecordStore.openRecordStore(rsname,true);
ByteArrayOutputStream baos=new ByteArrayOutputStream();
DataOutputStream dos=new DataOutputStream(baos);
dos.writeBoolean(Statics.russian);
dos.writeBoolean(Statics.grid);
dos.writeBoolean(Statics.extraBuffers);
dos.writeBoolean(Statics.bigImages);
dos.writeBoolean(Statics.touch);
dos.writeBoolean(Statics.randColor);
dos.writeInt(Statics.limit);
dos.writeInt(Statics.pers);
dos.writeInt(Statics.menuBack);
dos.writeInt(Statics.edBack);
dos.writeInt(Statics.curColor);
dos.writeInt(Statics.textColor);
dos.writeInt(Statics.gridColor);
dos.writeInt(Statics.menuTextColor);
dos.writeInt(Statics.background);
dos.writeInt(Statics.font.getSize());
dos.flush();
options=baos.toByteArray();
dos.close();
baos.close();
rs.setRecord(1,options,0,options.length);
}catch(Exception e){
try{
rs.addRecord(options,0,options.length);
}catch(Exception e2){}
}
try{
    rs.closeRecordStore();
    rs=null;
}catch(Exception e){}
  }
  
    public static Image resizeImage(Image oldImage,int newW,int newH){
    int oldW = oldImage.getWidth();
    int oldH = oldImage.getHeight();
    int[] pixels = new int[oldW*oldH];
   oldImage.getRGB(pixels,0,oldW,0, 0, oldW, oldH);
    int[] lines = new int[newW*oldH];
    int[] columns = new int[newW * newH];
      if (newW < oldW){
        for (int k = 0; k < oldH; k++) { // trough all lines
          int i = k * oldW; // index in old pix
          int j = k * newW; // index in new pix
          int part = newW;
          int addon = 0, r=0, g=0, b=0, a=0;
          for (int m=0; m<newW; m++){ ///OPTI ijm!!! need???
            int total = oldW;
            int R=0, G=0, B=0, A=0;
            if (addon!=0){
              R=r*addon; G=g*addon; B=b*addon; A=a*addon;
              total-=addon;
            }
            while (0<total){
              a = (pixels[i] >> 24) & 0xff;
              r = (pixels[i] >> 16) & 0xff;
              g = (pixels[i] >>  8) & 0xff;
              b =  pixels[i++]      & 0xff;
              if (total>part){
                R+=r*part; G+=g*part; B+=b*part; A+=a*part;
              }
              else{
                R+=r*total; G+=g*total; B+=b*total; A+=a*total;
                addon = part - total;
///set new pixel
                lines[j++]=((R/oldW)<<16)|((G/oldW)<<8)|
                    (B/oldW)|((A/oldW)<<24); // A??
              }
              total-=part;
            }
          }
        }
      }
      else{ /// newW > oldW
        int part = oldW;
        for (int k = 0; k < oldH; k++) { // trough all lines
          int i = k * oldW; // index in old pix
          int j = k * newW; // index in new pix
          int total= 0;
          int r=0, g=0, b=0, a=0;
          for (int m=0; m<newW; m++){
            int R=0, G=0, B=0, A=0;
            if (total>=part){
              R=r*part; G=g*part; B=b*part; A=a*part;
              total-=part;
            }
            else{
              if (0!=total){
                R=r*total; G=g*total; B=b*total; A=a*total;
              }
              a = (pixels[i] >> 24) & 0xff;
              r = (pixels[i] >> 16) & 0xff;
              g = (pixels[i] >>  8) & 0xff;
              b =  pixels[i++]      & 0xff;
              int addon = part - total;
              R+=r*addon; G+=g*addon; B+=b*addon; A+=a*addon;
              total=newW - addon;
            }
///set new pixel
            lines[j++]=((R/oldW)<<16)|((G/oldW)<<8)|
               (B/oldW)|((A/oldW)<<24); // A??
          }
        }
      }
/// проходим по столбцам
      if (newH < oldH) {
        for (int k = 0; k < newW; k++) { // trough columns
        int i = k; // index in lines pix
        int j = k; // index in new pix
        int part = newH;
        int addon = 0, r=0, g=0, b=0, a=0;
        for (int m=0; m<newH; m++){
          int total = oldH;
          int R=0, G=0, B=0, A=0;
          if (addon!=0){
            R=r*addon; G=g*addon; B=b*addon; A=a;//*addon;
            total-=addon;
          }
          while (0<total){
//            a = (lines[i] >> 24) & 0xff;// may no rotate
            a =  lines[i] & 0xff000000;
            r = (lines[i] >> 16) & 0xff;
            g = (lines[i] >> 8)  & 0xff;
            b =  lines[i]        & 0xff;
            i+=newW;
            if (total>part){
              R+=r*part; G+=g*part; B+=b*part; A+=a;//*part;
            }
            else{
              R+=r*total; G+=g*total; B+=b*total; A+=a;//*total;
              addon = part - total;
///set new pixel
              if (0!=A)
              columns[j]=((R/oldH)<<16)|((G/oldH)<<8)|
                 (B/oldH)|0xff000000; // A??
              else
              columns[j]=0;//((R/oldH)<<16)|((G/oldH)<<8)|(B/oldH); // A??
              j+=newW;
            }
            total-=part;
          }
        }
      }
    }
    else{
      int part = oldH;
      for (int k = 0; k < newW; k++) { // trough all lines
        int i = k; // index in old pix
        int j = k; // index in new pix
        int total= 0;
        int r=0, g=0, b=0, a=0;
        for (int m=0; m<newH; m++){
          int R=0, G=0, B=0, A=0;
          if (total>=part){
            R=r*part; G=g*part; B=b*part; A=a;//*part;
            total-=part;
          }
          else{
            if (0!=total){
              R=r*total; G=g*total; B=b*total; A=a;//*total;
            }
//            a = (lines[i] >> 24) & 0xff;// may no rotate
            a =  lines[i] & 0xff000000;
            r = (lines[i] >> 16) & 0xff;
            g = (lines[i] >>  8) & 0xff;
            b =  lines[i]        & 0xff;
            i+=newW;
            int addon = part - total;
            R+=r*addon; G+=g*addon; B+=b*addon; A+=a;//*addon;
            total=newH - addon;
          }
///set new pixel
          if (0!=A)
          columns[j]=((R/oldH)<<16)|((G/oldH)<<8)|
             (B/oldH)|0xff000000; // A??
          else
          columns[j]=0;//((R/oldH)<<16)|((G/oldH)<<8)|(B/oldH);

          j+=newW;
        }
      }
    }
      return Image.createRGBImage(columns,newW,newH,true);
  }
    
    public void fullReset(){
      String rsname="S3DEditor 0.6";
try{
    RecordStore.deleteRecordStore(rsname);
    notifyDestroyed();
}catch(Exception e){}
    }
  
}