//  ,   ,    :)

import java.util.Enumeration;
import java.util.Vector;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;

public class Menu
{
  public int textColor = 0x99;
  public int curColor = 0xffff00;
  public int selTextColor = 0x4444ff;
  public int index;
  public int sh;
  public int by;
  public int yy,hy;
  public String[] e;
  Font f;
  public short[] ave;

  public Menu(String[] s, Font font)
  {
    e = s;
    sh = font.getHeight();
    f = font; }

  public void paint(Graphics g, int px, int py, int w, int h, int align) {
    yy = py;
    hy=h;
    g.setFont(f);
    g.setColor(curColor);
    int y = py + sh * index + by;
    //if ((y > h + py - sh))
      //by -= sh;
    //if(y > py+sh)
      //by -= sh;
    g.fillRect(px, y, w, sh);
    for (int i = 0; i < e.length; ++i) {
      int z = i * sh + py + by;
      if(z>=py+h)continue;
      if(i==index){g.setColor(selTextColor);
      }
      else g.setColor(textColor);
      if (align == 0)
        g.drawString(e[i], px, z, 20);
      else if (align == 1)
        g.drawString(e[i], w / 2 + px, z, 17);
      else
        g.drawString(e[i], px + w, z, 24); 
    }
  }

  public void up() {
    index -= 1;
    if (index < 0){
      index = (e.length - 1);
      if(by+yy+sh*index>yy+hy-sh)by=-sh*index+hy-sh;
    }
    if(ave!=null)
        for(int i=0;i<ave.length;i++)if(index==ave[i])up();
    if(by+yy+sh*index<yy)by+=sh;
    //if(by+sh*index>hy)by=-sh*index;
  }

  public void down() {
    index += 1;
    if (index >= e.length){
      index = 0;
      if(by+yy+sh*index<yy)by=0;
    }
    if(ave!=null)
        for(int i=0;i<ave.length;i++)if(index==ave[i])down();
    //if(by+sh*index<yy)by=sh*index;
    if(by+yy+sh*index>yy+hy-sh)by-=sh;
  }
  public void move(int yp){
      if(yp>0&&by<=0)by+=yp;
      if(yp<0&&by+yy+e.length*sh>=yy+hy) by+=yp;
  }

  public int getTouchIndex(int y) {
    int touch = (y - yy - by) / sh;
    if ((touch < e.length) && (touch >= 0))
      return touch;
    return 16777215; }
  
  public int getSize(){
      return e.length;
  }

  public String getSelestedName() {
    return e[index]; }
  
  public void setElems(Enumeration en,boolean bl){
      Vector v=new Vector();
      if(bl)v.addElement(". .");
      while(en.hasMoreElements())
          v.addElement(en.nextElement().toString());
      e=new String[v.size()];
      v.copyInto(e);
      by=0;
  }

  public void setElems(String[] s) {
    e = s;
    index = 0; }

  public void setElem(int i, String s) {
    if ((i >= 0) && (i < e.length))
      e[i] = s;
  }
}