// . , 

import javax.microedition.lcdui.Graphics;
import java.util.Vector;

public class Triangle extends Face
{
  public Vertex a; // 
  public Vertex b;
  public Vertex c;
  public float nx; // 
  public float ny;
  public float nz;
  public float rnx,rny,rnz;
  public float k;
  public boolean smooth=true; //    
  public Material material=null; // 
  public float[] uv; //  

  public Triangle(Vertex v1, Vertex v2, Vertex v3, int col)
  {
    a = v1;
    b = v2;
    c = v3;
    color = col;
  }
  public void norm(){ //   
      float tnx = (a.y - b.y) * (a.z - c.z) - (a.z - b.z) * (a.y - c.y);
    float tny = (a.z - b.z) * (a.x - c.x) - (a.x - b.x) * (a.z - c.z);
    float tnz = (a.x - b.x) * (a.y - c.y) - (a.y - b.y) * (a.x - c.x);
    double length = Math.sqrt(tnx * tnx + tny * tny + tnz * tnz);
    tnx = (float)(tnx / ((length == 0D) ? 1D : length));
    tny = (float)(tny / ((length == 0D) ? 1D : length));
    tnz = (float)(tnz / ((length == 0D) ? 1D : length));
    rnx= nx = tnx;
    rny= ny = tny;
    rnz = nz = tnz; }
  
  public void norm(float x,float y,float z){
      rnx=nx=x;
      rny=ny=y;
      rnz=nz=z;
  }
  
  public void setUV(float[] in){
      uv=in;
  }
  public void setUV(){
      uv=new float[]{a.u,a.v,b.u,b.v,c.u,c.v};
  }
  
  public void invert(){
      nx*=-1;
      ny*=-1;
      nz*=-1;
  }

  public int getS() {
    return ((a.zc + b.zc + c.zc) / 3);
  }
  
  public void paintFlat(Graphics g){
      paint(g,color,0);
  }

  public void paint(Graphics g,int v)
  {
    int rc = color >> 16 & 0xFF; int gc = color >> 8 & 0xFF; int bc = color & 0xFF;
    rc = (int)(rc * -k);
    gc = (int)(gc * -k);
    bc = (int)(bc * -k);
    paint(g, rc << 16 | gc << 8 | bc,v);
  }

  // col - , v - :     
  public void paint(Graphics g, int col,int v) {
      double dis=1;
    g.setColor(col);
    if(v!=0){
        dis=(double)Main.main.e.dist;
        if(dis>0)dis=(dis/10000)+0.1;
        else if(dis==0)dis=0.1;
        else dis=0.1+dis/100000;
    }
    if(v==0)g.fillTriangle(a.sx, a.sy, b.sx, b.sy, c.sx, c.sy);
    else if(v==1){
        int x0=Main.main.e.xo;
      int z0=Main.main.e.zo;
     // int scale=1;
      g.fillTriangle((int)(Statics.w/2+x0*dis+a.x*dis),(int)(Statics.h/2-z0*dis-a.z*dis),(int)(Statics.w/2+x0*dis+b.x*dis),(int)(Statics.h/2-z0*dis-b.z*dis),(int)(Statics.w/2+x0*dis+c.x*dis),(int)(Statics.h/2-z0*dis-c.z*dis));
    }
    else if(v==2){
        int y0=Main.main.e.yo;
      int z0=Main.main.e.zo;
      //int scale=1;
      g.fillTriangle((int)(Statics.w/2+z0*dis+a.z*dis),(int)(Statics.h/2-y0*dis-a.y*dis),(int)(Statics.w/2+z0*dis+b.z*dis),(int)(Statics.h/2-y0*dis-b.y*dis),(int)(Statics.w/2+z0*dis+c.z*dis),(int)(Statics.h/2-y0*dis-c.y*dis));
    }
    else if(v==3){
         int y0=Main.main.e.yo;
      int x0=Main.main.e.xo;
     // int scale=1;
      g.fillTriangle((int)(Statics.w/2+x0*dis+a.x*dis),(int)(Statics.h/2-y0*dis-a.y*dis),(int)(Statics.w/2+x0*dis+b.x*dis),(int)(Statics.h/2-y0*dis-b.y*dis),(int)(Statics.w/2+x0*dis+c.x*dis),(int)(Statics.h/2-y0*dis-c.y*dis));
    }
  }

  public void setVertexMatrix(Matrix3D m) {
    a.setMatrix(m);
    b.setMatrix(m);
    c.setMatrix(m);
  }
  public boolean isVisible(int v){ //    
      if(v==0){
      if(a.zc<-Vertex.dist&&b.zc<-Vertex.dist&&c.zc<-Vertex.dist) return false;
      if(a.zc>Statics.limit&&b.zc>Statics.limit&&c.zc>Statics.limit) return false;
      if((a.sx<0&&b.sx<0&&c.sx<0)||(a.sx>Statics.w&&b.sx>Statics.w&&c.sx>Statics.w))return false;
      if((a.sy<0&&b.sy<0&&c.sy<0)||(a.sy>Statics.h&&b.sy>Statics.h&&c.sy>Statics.h)) return false;
          if(material!=null&&material.doubleSided)return true;
      if(/*(material==null||material.opacity==255)&&*/rnz>0)return false;
      }
      else{
        double dis=(double)Main.main.e.dist;
        if(dis>0)dis=dis/10000+0.1;
        else if(dis==0)dis=0.1;
        else dis=0.1+dis/100000;
        int x0=Main.main.e.xo;
      int z0=Main.main.e.zo;
      int y0=Main.main.e.yo;
          int w=Statics.w,h=Statics.h;
          if(((a.x*dis+x0*dis<-w/2&&b.x*dis+x0*dis<-w/2&&c.x*dis+x0*dis<-w/2)||(a.x*dis+x0*dis>w/2&&b.x*dis+x0*dis>w/2&&c.x*dis+x0*dis>w/2))&&(v==1||v==3))return false;
          if(((a.z*dis+z0*dis<-h/2&&b.z*dis+z0*dis<-h/2&&c.z*dis+z0*dis<-h/2)||(a.z*dis+z0*dis>h/2&&b.z*dis+z0*dis>h/2&&c.z*dis+z0*dis>h/2))&&v==1)return false;
          if(((a.z*dis+z0*dis<-w/2&&b.z*dis+z0*dis<-w/2&&c.z*dis+z0*dis<-w/2)||(a.z*dis+z0*dis>w/2&&b.z*dis+z0*dis>w/2&&c.z*dis+z0*dis>w/2))&&v==2)return false;
          if(((a.y*dis+y0*dis<-h/2&&b.y*dis+y0*dis<-h/2&&c.y*dis+y0*dis<-h/2)||(a.y*dis+y0*dis>h/2&&b.y*dis+y0*dis>h/2&&c.y*dis+y0*dis>h/2))&&(v==3||v==2))return false;
      }
      return true;
  }

  public void setMatrix(Matrix3D m)
  {
    rnx = (nx * m.xx + ny * m.xy + nz * m.xz);
    rny = (nx * m.yx + ny * m.yy + nz * m.yz);
    rnz = (nx * m.zx + ny * m.zy + nz * m.zz);
  }
  
  public void soequal(){
      nx=rnx;
      ny=rny;
      nz=rnz;
      double length = Math.sqrt(nx * nx + ny * ny + nz * nz);
    nx = (float)(nx / ((length == 0D) ? 1D : length));
    ny = (float)(ny / ((length == 0D) ? 1D : length));
    nz = (float)(nz / ((length == 0D) ? 1D : length));
  }
  
  public void light(Vector l){ //      (    )
      if(l!=null&&!l.isEmpty()){
    int mx=(a.xc+b.xc+c.xc)/3;
    int my=(a.yc+b.yc+c.yc)/3;
         k=0;
         float kk;
         for(int i=0;i<l.size();i++){
             if(l.elementAt(i)==null)continue;
             Light li=(Light)l.elementAt(i);
      float lx=mx-li.xc,ly=my-li.yc,lz=getS()-li.zc;
    double len=Math.sqrt(lx*lx+ly*ly+lz*lz);
    lx/=len;
    ly/=len;
    lz/=len;
    kk=(lx*rnx+ly*rny+lz*rnz);
    if(kk>0){if(material!=null&&material.doubleSided)kk=-kk; else kk=0;}
    kk*=li.s;
         k+=kk;
         }
         }
     else{
         k=rnz;
         if(k>0){if(material!=null&&material.doubleSided)k=-k; else k=0;}
     }
  }
  
  //  . r -  , z -  , s -  , v - 
  public void render(int[] r,int[] z,int s,int v){
      if(v!=0){
          switch(v){
              case 1: top(r,z,s);break;
              case 2: right(r,z,s);break;
              case 3: front(r,z,s);break;
          }
          return;
      }
      byte culling=0; //      , ..        Z < 0.
	  //               ,       . .
      Vertex ver1=null,ver2=null,ver3=null,ver4=null,ver5=null;
      if(a.zc<-Vertex.dist&&b.zc>-Vertex.dist&&c.zc>-Vertex.dist||b.zc<-Vertex.dist&&a.zc>-Vertex.dist&&c.zc>-Vertex.dist||c.zc<-Vertex.dist&&a.zc>-Vertex.dist&&b.zc>-Vertex.dist){
          culling=1;
          if(a.zc<-Vertex.dist){ver1=a;ver2=b;ver3=c;if(uv!=null){ver2.u=uv[2];ver2.v=uv[3];ver3.u=uv[4];ver3.v=uv[5];} }
          else if(b.zc<-Vertex.dist){ver1=b;ver2=a;ver3=c;if(uv!=null){ver2.u=uv[0];ver2.v=uv[1];ver3.u=uv[4];ver3.v=uv[5];} }
          else{ ver1=c;ver2=a;ver3=b;if(uv!=null){ver2.u=uv[0];ver2.v=uv[1];ver3.u=uv[2];ver3.v=uv[3];} }
          ver4=new Vertex();
          ver5=new Vertex();
          ver4.zc=-Vertex.dist+1;
          ver5.zc=-Vertex.dist+1;
          ver4.xc=ver2.xc + (ver1.xc - ver2.xc) * (-Vertex.dist+1 - ver2.zc) / (ver1.zc - ver2.zc);
          ver4.yc=ver2.yc + (ver1.yc - ver2.yc) * (-Vertex.dist+1 - ver2.zc) / (ver1.zc - ver2.zc);
          ver4.k=ver2.k + (ver1.k - ver2.k) * (-Vertex.dist+1 - ver2.zc) / (ver1.zc - ver2.zc);
          ver4.u=ver2.u + (ver1.u - ver2.u) * (-Vertex.dist+1 - ver2.zc) / (ver1.zc - ver2.zc);
          ver4.v=ver2.v + (ver1.v - ver2.v) * (-Vertex.dist+1 - ver2.zc) / (ver1.zc - ver2.zc);
          ver5.xc=ver3.xc + (ver1.xc - ver3.xc) * (-Vertex.dist+1 - ver3.zc) / (ver1.zc - ver3.zc);
          ver5.yc=ver3.yc + (ver1.yc - ver3.yc) * (-Vertex.dist+1 - ver3.zc) / (ver1.zc - ver3.zc);
          ver5.k=ver3.k + (ver1.k - ver3.k) * (-Vertex.dist+1 - ver3.zc) / (ver1.zc - ver3.zc);
          ver5.u=ver3.u + (ver1.u - ver3.u) * (-Vertex.dist+1 - ver3.zc) / (ver1.zc - ver3.zc);
          ver5.v=ver3.v + (ver1.v - ver3.v) * (-Vertex.dist+1 - ver3.zc) / (ver1.zc - ver3.zc);
          ver4.to2d();
          ver5.to2d();
      }
      if(a.zc<-Vertex.dist&&b.zc<-Vertex.dist||a.zc<-Vertex.dist&&c.zc<-Vertex.dist||b.zc<-Vertex.dist&&c.zc<-Vertex.dist){
          if(a.zc>-Vertex.dist){ver1=a;ver2=b;ver3=c;if(uv!=null){ver2.u=uv[2];ver2.v=uv[3];ver3.u=uv[4];ver3.v=uv[5];} }
          else if(b.zc>-Vertex.dist){ver1=b;ver2=a;ver3=c;if(uv!=null){ver2.u=uv[0];ver2.v=uv[1];ver3.u=uv[4];ver3.v=uv[5];} }
          else{ver1=c;ver2=a;ver3=b;if(uv!=null){ver2.u=uv[0];ver2.v=uv[1];ver3.u=uv[2];ver3.v=uv[3];} }
          ver4=new Vertex();
          ver5=new Vertex();
          ver4.zc=-Vertex.dist+1;
          ver5.zc=-Vertex.dist+1;
          ver4.xc=ver2.xc + (ver1.xc - ver2.xc) * (-Vertex.dist+1 - ver2.zc) / (ver1.zc - ver2.zc);
          ver4.yc=ver2.yc + (ver1.yc - ver2.yc) * (-Vertex.dist+1 - ver2.zc) / (ver1.zc - ver2.zc);
          ver4.k=ver2.k + (ver1.k - ver2.k) * (-Vertex.dist+1 - ver2.zc) / (ver1.zc - ver2.zc);
          ver4.u=ver2.u + (ver1.u - ver2.u) * (-Vertex.dist+1 - ver2.zc) / (ver1.zc - ver2.zc);
          ver4.v=ver2.v + (ver1.v - ver2.v) * (-Vertex.dist+1 - ver2.zc) / (ver1.zc - ver2.zc);
          ver5.xc=ver3.xc + (ver1.xc - ver3.xc) * (-Vertex.dist+1 - ver3.zc) / (ver1.zc - ver3.zc);
          ver5.yc=ver3.yc + (ver1.yc - ver3.yc) * (-Vertex.dist+1 - ver3.zc) / (ver1.zc - ver3.zc);
          ver5.k=ver3.k + (ver1.k - ver3.k) * (-Vertex.dist+1 - ver3.zc) / (ver1.zc - ver3.zc);
          ver5.u=ver3.u + (ver1.u - ver3.u) * (-Vertex.dist+1 - ver3.zc) / (ver1.zc - ver3.zc);
          ver5.v=ver3.v + (ver1.v - ver3.v) * (-Vertex.dist+1 - ver3.zc) / (ver1.zc - ver3.zc);
          ver4.to2d();
          ver5.to2d();
          culling=2;}
          if(s==0){
              if(material==null){
                  int rc = color >> 16 & 0xFF; int gc = color >> 8 & 0xFF; int bc = color & 0xFF;
    rc = (int)(rc * -k);
    if(rc>255)rc=255;
    if(rc<0)rc=0;
    gc = (int)(gc * -k);
    if(gc>255)gc=255;
    if(gc<0)gc=0;
    bc = (int)(bc * -k);
    if(bc>255)bc=255;
    if(bc<0)bc=0;
      if(culling==0)
          renderFlatTriangle(r,z,a,b,c,rc << 16 | gc << 8 | bc);
      else if(culling==1){
          renderFlatTriangle(r,z,ver3,ver2,ver4,rc << 16 | gc << 8 | bc);
          renderFlatTriangle(r,z,ver3,ver4,ver5,rc << 16 | gc << 8 | bc);
      }
      else renderFlatTriangle(r,z,ver1,ver4,ver5,rc << 16 | gc << 8 | bc);
              }
              else{
                  if(material.texture==null||material.useFaceColor){
    int rc = (material.useFaceColor?color:material.diffuseColor) >> 16 & 0xFF; int gc = (material.useFaceColor?color:material.diffuseColor) >> 8 & 0xFF; int bc = (material.useFaceColor?color:material.diffuseColor) & 0xFF;
    rc = (int)(rc * -k);
    if(rc>255)rc=255;
    if(rc<0)rc=0;
    gc = (int)(gc * -k);
    if(gc>255)gc=255;
    if(gc<0)gc=0;
    bc = (int)(bc * -k);
    if(bc>255)bc=255;
    if(bc<0)bc=0;
      if(culling==0)renderFlatTriangle(r,z,a,b,c,rc << 16 | gc << 8 | bc);
      else if(culling==1){renderFlatTriangle(r,z,ver3,ver2,ver4,rc << 16 | gc << 8 | bc);
          renderFlatTriangle(r,z,ver3,ver4,ver5,rc << 16 | gc << 8 | bc);
      }
      else renderFlatTriangle(r,z,ver1,ver4,ver5,rc << 16 | gc << 8 | bc);
                  }
                  else{
                      if(uv!=null){
                          if(culling==0)renderAffineTexturedTriangle(material,r,z,uv,a,b,c,-k);
                  else if(culling==1){renderAffineTexturedTriangle(material,r,z,uv,ver3,ver2,ver4,-k);
                  renderAffineTexturedTriangle(material,r,z,uv,ver3,ver4,ver5,-k);}
                  else renderAffineTexturedTriangle(material,r,z,uv,ver1,ver4,ver5,-k);
                      }
                      else{
                          if(culling==0)renderAffineTexturedTriangle(material,r,z,a,b,c,-k);
                  else if(culling==1){renderAffineTexturedTriangle(material,r,z,ver3,ver2,ver4,-k);
                  renderAffineTexturedTriangle(material,r,z,ver3,ver4,ver5,-k);}
                  else renderAffineTexturedTriangle(material,r,z,ver1,ver4,ver5,-k);
                      }
                  }
              }
          }
          else if(s==1){
              if(material==null){
                  if(!smooth){
                      int rc = color >> 16 & 0xFF; int gc = color >> 8 & 0xFF; int bc = color & 0xFF;
    rc = (int)(rc * -k);
    if(rc>255)rc=255;
    if(rc<0)rc=0;
    gc = (int)(gc * -k);
    if(gc>255)gc=255;
    if(gc<0)gc=0;
    bc = (int)(bc * -k);
    if(bc>255)bc=255;
    if(bc<0)bc=0;
      if(culling==0)
          renderFlatTriangle(r,z,a,b,c,rc << 16 | gc << 8 | bc);
      else if(culling==1){
          renderFlatTriangle(r,z,ver3,ver2,ver4,rc << 16 | gc << 8 | bc);
          renderFlatTriangle(r,z,ver3,ver4,ver5,rc << 16 | gc << 8 | bc);
      }
      else renderFlatTriangle(r,z,ver1,ver4,ver5,rc << 16 | gc << 8 | bc);
                  }
                  else{
                      if(culling==0)
          renderTriangle(r,z,a,b,c,color);
      else if(culling==1){
          renderTriangle(r,z,ver3,ver2,ver4,color);
          renderTriangle(r,z,ver3,ver4,ver5,color);
      }
      else renderTriangle(r,z,ver1,ver4,ver5,color);
                  }
              }
              else{
                  if(material.texture==null||material.useFaceColor){
                      if(!smooth){
                          int rc = (material.useFaceColor?color:material.diffuseColor) >> 16 & 0xFF; int gc = (material.useFaceColor?color:material.diffuseColor) >> 8 & 0xFF; int bc = (material.useFaceColor?color:material.diffuseColor) & 0xFF;
    int rrc = (int)(rc * -k+rc*material.self);
    if(rrc>rc)rrc=rc;
    if(rc<0)rc=0;
    int rgc = (int)(gc * -k+gc*material.self);
    if(rgc>gc)rgc=gc;
    if(gc<0)gc=0;
    int rbc = (int)(bc * -k+bc*material.self);
    if(rbc>bc)rbc=bc;
    if(bc<0)bc=0;
      if(culling==0)renderFlatTriangle(r,z,a,b,c,rrc << 16 | rgc << 8 | rbc,material.opacity);
      else if(culling==1){renderFlatTriangle(r,z,ver3,ver2,ver4,rrc << 16 | rgc << 8 | rbc,material.opacity);
          renderFlatTriangle(r,z,ver3,ver4,ver5,rrc << 16 | rgc << 8 | rbc,material.opacity);
      }
      else renderFlatTriangle(r,z,ver1,ver4,ver5,rrc << 16 | rgc << 8 | rbc,material.opacity);
                      }
                      else{
                          int col=0;
                          if(material.useFaceColor){
                              col=material.diffuseColor;
                          material.diffuseColor=color;}
                          if(culling==0)renderTriangle(r,z,a,b,c,material);
      else if(culling==1){renderTriangle(r,z,ver3,ver2,ver4,material);
          renderTriangle(r,z,ver3,ver4,ver5,material);
      }
      else renderTriangle(r,z,ver1,ver4,ver5,material);
                          if(material.useFaceColor)material.diffuseColor=col;
                      }
                  }
                  else{
                      if(!smooth){
                          if(uv!=null){
                              if(culling==0)renderAffineTexturedTriangle(material,r,z,uv,a,b,c,-k);
                  else if(culling==1){renderAffineTexturedTriangle(material,r,z,uv,ver3,ver2,ver4,-k);
                  renderAffineTexturedTriangle(material,r,z,uv,ver3,ver4,ver5,-k);}
                  else renderAffineTexturedTriangle(material,r,z,uv,ver1,ver4,ver5,-k);
                      }
                      else{
                          if(culling==0)renderAffineTexturedTriangle(material,r,z,a,b,c,-k);
                  else if(culling==1){renderAffineTexturedTriangle(material,r,z,ver3,ver2,ver4,-k);
                  renderAffineTexturedTriangle(material,r,z,ver3,ver4,ver5,-k);}
                  else renderAffineTexturedTriangle(material,r,z,ver1,ver4,ver5,-k);
                          }
                      }
                      else{
                          if(uv!=null){
                              if(culling==0)renderAffineTexturedTriangle(material,r,z,uv,a,b,c);
                  else if(culling==1){renderAffineTexturedTriangle(material,r,z,uv,ver3,ver2,ver4);
                  renderAffineTexturedTriangle(material,r,z,uv,ver3,ver4,ver5);}
                  else renderAffineTexturedTriangle(material,r,z,uv,ver1,ver4,ver5);
                      }
                      else{
                          if(culling==0)renderAffineTexturedTriangle(material,r,z,a,b,c);
                  else if(culling==1){renderAffineTexturedTriangle(material,r,z,ver3,ver2,ver4);
                  renderAffineTexturedTriangle(material,r,z,ver3,ver4,ver5);}
                  else renderAffineTexturedTriangle(material,r,z,ver1,ver4,ver5);
                          }
                      }
                  }
              }
          }
          else if(s==2){
              if(culling==0)renderFlatTriangle(r,z,a,b,c,color);
              else if(culling==1){renderFlatTriangle(r,z,ver3,ver2,ver4,color);
              renderFlatTriangle(r,z,ver3,ver5,ver4,color);
              }
              else renderFlatTriangle(r,z,ver1,ver5,ver4,color);
          }
          else if(s==3){
              
              if(culling==0){
              drawLine(r,z,a,b,color);
              drawLine(r,z,a,c,color);
              drawLine(r,z,b,c,color);}
              else if(culling==1){renderFlatTriangle(r,z,ver3,ver2,ver4,color);
              renderFlatTriangle(r,z,ver3,ver5,ver4,color);
              drawLine(r,z,ver3,ver2,color);
              drawLine(r,z,ver3,ver5,color);
              drawLine(r,z,ver2,ver4,color);
//              drawLine(r,z,ver4,ver5,color);
              }
              else{ renderFlatTriangle(r,z,ver1,ver5,ver4,color);
              drawLine(r,z,ver1,ver5,color);
              drawLine(r,z,ver1,ver4,color);
//              drawLine(r,z,ver4,ver5,color);
              }
          }
  }
  
  private void top(int[] r,int[] z,int s){
      int x0=Main.main.e.xo;
      int z0=Main.main.e.zo;
      double scale=(double)Main.main.e.dist;
        if(scale>0)scale=scale/10000+0.1;
        else if(scale==0)scale=0.1;
        else scale=0.1+scale/100000;
      render(r,(int)(Statics.w/2+x0*scale+a.x*scale),(int)(Statics.h/2-z0*scale-a.z*scale),(int)(Statics.w/2+x0*scale+b.x*scale),(int)(Statics.h/2-z0*scale-b.z*scale),(int)(Statics.w/2+x0*scale+c.x*scale),(int)(Statics.h/2-z0*scale-c.z*scale),s);
  }
      
        private void right(int[] r,int[] z,int s){
      int y0=Main.main.e.yo;
      int z0=Main.main.e.zo;
      double scale=(double)Main.main.e.dist;
        if(scale>0)scale=scale/10000+0.1;
        else if(scale==0)scale=0.1;
        else scale=0.1+scale/100000;
      render(r,(int)(Statics.w/2+z0*scale+a.z*scale),(int)(Statics.h/2-y0*scale-a.y*scale),(int)(Statics.w/2+z0*scale+b.z*scale),(int)(Statics.h/2-y0*scale-b.y*scale),(int)(Statics.w/2+z0*scale+c.z*scale),(int)(Statics.h/2-y0*scale-c.y*scale),s);
  }
        
          private void front(int[] r,int[] z,int s){
      int y0=Main.main.e.yo;
      int x0=Main.main.e.xo;
      double scale=(double)Main.main.e.dist;
        if(scale>0)scale=scale/10000+0.1;
        else if(scale==0)scale=0.1;
        else scale=0.1+scale/100000;
      render(r,(int)(Statics.w/2+x0*scale+a.x*scale),(int)(Statics.h/2-y0*scale-a.y*scale),(int)(Statics.w/2+x0*scale+b.x*scale),(int)(Statics.h/2-y0*scale-b.y*scale),(int)(Statics.w/2+x0*scale+c.x*scale),(int)(Statics.h/2-y0*scale-c.y*scale),s);
  }
            
          private void render(int[] r,int asx,int asy,int bsx,int bsy,int csx,int csy,int s){
         if(s==0||s==1){
             int rc = color >> 16 & 0xFF; int gc = color >> 8 & 0xFF; int bc = color & 0xFF;
             rc = (int)(rc * -k);
    if(rc>255)rc=255;
    if(rc<0)rc=0;
    gc = (int)(gc * -k);
    if(gc>255)gc=255;
    if(gc<0)gc=0;
    bc = (int)(bc * -k);
    if(bc>255)bc=255;
    if(bc<0)bc=0;
              renderTriangle(r,asx,asy,bsx,bsy,csx,csy,rc << 16 | gc << 8 | bc);
          }
         else if(s==2){
             renderTriangle(r,asx,asy,bsx,bsy,csx,csy,color);
         }
         else if(s==3){
              drawLine(r,asx,asy,bsx,bsy,color);
              drawLine(r,asx,asy,csx,csy,color);
              drawLine(r,bsx,bsy,csx,csy,color);
         }
          }
          
}