// 

import java.util.Vector;

public class Vertex
{
  public int sx;
  public int sy;
  public int xc;
  public int yc;
  public int zc;
  public int x;
  public int y;
  public int z;
  public float nx;
  public float ny;
  public float nz;
  public float rnx;
  public float rny;
  public float rnz;
  public int k;
  public float u,v;
/*  
  public float cc;
  public float uz;
  public float vz;
  public float z1;*/
  public static int dist=3000;

  public Vertex()
  {
  }

  public Vertex(int a1, int a2, int a3)
  {
    xc = (x = a1);
    yc = (y = a2);
    zc = (z = a3);
    to2d(); }

  public Vertex(Vertex v) {
    x = v.x;
    y = v.y;
    z = v.z;
    nx=v.nx;
    ny=v.ny;
    nz=v.nz;
    xc = v.xc;
    yc = v.yc;
    zc = v.zc;
    u=v.u;
    this.v=v.u;
    to2d(); }
  
    public void sn(float rx,float ry,float rz){
    nx=rx;
    ny=ry;
    nz=rz;
  }
    
    public void setUV(float a,float b){
        u=a;
        v=b;
    }

  public void setMatrix(Matrix3D m) {
    xc = (int)(x * m.xx + y * m.xy + z * m.xz);
    yc = (int)(x * m.yx + y * m.yy + z * m.yz);
    zc = (int)(x * m.zx + y * m.zy + z * m.zz);
    xc += (int)m.xo;
    yc += (int)m.yo;
    zc += (int)m.zo;
    rnx = (nx * m.xx + ny * m.xy + nz * m.xz);
    rny = (nx * m.yx + ny * m.yy + nz * m.yz);
    rnz = (nx * m.zx + ny * m.zy + nz * m.zz);
    to2d(); }

  public void to2d() {
      if(zc==-dist){
          zc=-dist+1;
      }
      if(zc>-dist){ //         Z < 0,        ,           .
   // int z2 = (zc > -dist) ? zc : -dist-1;

          int z2=zc+dist;
    sx = (Statics.w / 2 + xc * Statics.pers / z2);
    sy = (Statics.h / 2 - yc * Statics.pers / z2);}
    /*  else if(zc<-dist){
          int z2=zc+dist;
    sx = (Statics.w / 2 - xc*z2/Statics.pers);
    sy = (Statics.h / 2 + yc*z2/Statics.pers);
      }*/
    /*  else{
    sx = (Statics.w / 2 + xc);//*Statics.pers/5);
    sy = (Statics.h / 2 - yc);//*Statics.pers/5);
      }*/
  }
  
  public void light(Vector l){ //           
     if(l!=null&&!l.isEmpty()){
         k=0;
         int kk;
         for(int i=0;i<l.size();i++){
             if(l.elementAt(i)==null)continue;
             Light li=(Light)l.elementAt(i);
      float lx=xc-li.xc,ly=yc-li.yc,lz=zc-li.zc;
    double len=Math.sqrt(lx*lx+ly*ly+lz*lz);
    lx/=len;
    ly/=len;
    lz/=len;
    kk=(int)((lx*rnx+ly*rny+lz*rnz)*100)<<16;
    if(kk>0)kk=0;
    kk*=-li.s;
         k+=kk;
         }
         }
     else{
         float kk=-rnz;
         //if(kk>0)kk=0;
         //kk*=-1;
         k=(int)((kk)*100)<<16;
     }
  }

  public void move(int a, int b, int c) {
    x += a;
    y += b;
    z += c; }
  
  public void normalize(){
    double length = Math.sqrt(nx * nx + ny * ny + nz * nz);
    nx = (float)(nx / ((length == 0D) ? 1D : length));
    ny = (float)(ny / ((length == 0D) ? 1D : length));
    nz = (float)(nz / ((length == 0D) ? 1D : length));
}

  public void soequal() {
    x = xc;
    y = yc;
    z = zc;}
  public void soeqNorm(){
    nx=rnx;
    ny=rny;
    nz=rnz;
  }
  
  public static int[] unProject(Matrix3D m,int xs,int ys){ //    3D
      float a=Statics.pers*m.xx-xs*m.zx+Statics.w/2*m.zx, b=Statics.pers*m.xz-xs*m.zz+Statics.w/2*m.zz;
      float c=Statics.pers*m.yx-Statics.h/2*m.zx+ys*m.zx, d=Statics.pers*m.yz-Statics.h/2*m.zz+ys*m.zz;
      float e=xs*m.zo+xs*dist-Statics.w/2*m.zo-Statics.w/2*dist-Statics.pers*m.xo, f=Statics.h/2*m.zo+Statics.h/2*dist-ys*m.zo-ys*dist-Statics.pers*m.yo;
      return new int[]{(int)((e*d-b*f)/(a*d-c*b)),(int)((a*f-c*e)/(a*d-c*b))};
  }
}